// This is a generated system top level RTL file. 
// Parameters are taken by 'create_ghrd_top.tcl' in order to 
// generate appropriate RTL top based on system requirement.

module ghrd_a10_top (
// FPGA peripherals ports
input  wire [3:0]  fpga_dipsw_pio,                   
output wire [3:0]  fpga_led_pio,                     
input  wire [3:0]  fpga_button_pio,  
// HPS memory controller ports
// DDR4 single rank -2133 device
output wire          hps_memory_mem_act_n,
output wire          hps_memory_mem_bg,
output wire          hps_memory_mem_par,
input  wire          hps_memory_mem_alert_n,
inout  wire [4-1:0]  hps_memory_mem_dbi_n,
output wire [16:0]   hps_memory_mem_a,                           
output wire [1:0]    hps_memory_mem_ba,
output wire          hps_memory_mem_ck,                          
output wire          hps_memory_mem_ck_n,                        
output wire          hps_memory_mem_cke,                         
output wire          hps_memory_mem_cs_n,                                            
output wire          hps_memory_mem_reset_n,                     
inout  wire [32-1:0] hps_memory_mem_dq,                          
inout  wire [4-1:0]  hps_memory_mem_dqs,                         
inout  wire [4-1:0]  hps_memory_mem_dqs_n,                       
output wire          hps_memory_mem_odt,                                          
input  wire          hps_memory_oct_rzqin,     
input  wire          emif_ref_clk,  
// HPS peripherals
output wire          hps_emac0_TX_CLK,   
output wire          hps_emac0_TXD0,     
output wire          hps_emac0_TXD1,     
output wire          hps_emac0_TXD2,     
output wire          hps_emac0_TXD3,     
input  wire          hps_emac0_RXD0,     
inout  wire          hps_emac0_MDIO,     
output wire          hps_emac0_MDC,      
input  wire          hps_emac0_RX_CTL,   
output wire          hps_emac0_TX_CTL,   
input  wire          hps_emac0_RX_CLK,   
input  wire          hps_emac0_RXD1,     
input  wire          hps_emac0_RXD2,     
input  wire          hps_emac0_RXD3, 
inout  wire          hps_usb0_D0,        
inout  wire          hps_usb0_D1,        
inout  wire          hps_usb0_D2,        
inout  wire          hps_usb0_D3,        
inout  wire          hps_usb0_D4,        
inout  wire          hps_usb0_D5,        
inout  wire          hps_usb0_D6,        
inout  wire          hps_usb0_D7,        
input  wire          hps_usb0_CLK,       
output wire          hps_usb0_STP,       
input  wire          hps_usb0_DIR,       
input  wire          hps_usb0_NXT,   
output wire          hps_spim1_CLK,
output wire          hps_spim1_MOSI,
input  wire          hps_spim1_MISO,
output wire          hps_spim1_SS0_N,
output wire          hps_spim1_SS1_N,
input  wire          hps_uart1_RX,       
output wire          hps_uart1_TX,       
inout  wire          hps_i2c1_SDA,       
inout  wire          hps_i2c1_SCL,       
inout  wire          hps_sdio_CMD,
output wire          hps_sdio_CLK,
inout  wire          hps_sdio_D0,
inout  wire          hps_sdio_D1,
inout  wire          hps_sdio_D2,
inout  wire          hps_sdio_D3,
inout  wire          hps_sdio_D4,
inout  wire          hps_sdio_D5,
inout  wire          hps_sdio_D6,
inout  wire          hps_sdio_D7,
output wire          hps_trace_CLK,      
output wire          hps_trace_D0,       
output wire          hps_trace_D1,       
output wire          hps_trace_D2,       
output wire          hps_trace_D3,         
inout  wire          hps_gpio_GPIO14,    
inout  wire          hps_gpio_GPIO05,
inout  wire          hps_gpio_GPIO16,    
inout  wire          hps_gpio_GPIO17, 
// Other HPS-FPGA peripherals
input  wire  			dp_refclk,
input  wire  			tx_hpd,
output wire 			dp_on,
inout  wire  			dp_aux_ch_p,
inout  wire  			dp_aux_ch_n,
output wire [3:0] 		dp_tx_serial_out,
// FPGA clock and reset
input  wire          fpga_clk_100,
input  wire          fpga_reset_n  
);

// internal wires and registers declaration
wire [3:0]  fpga_debounced_buttons;
wire [3:0]  fpga_led_internal;
wire [27:0] stm_hw_events;
wire        hps_fpga_reset;
wire [2:0]  hps_reset_req;
wire        hps_cold_reset;
wire        hps_warm_reset;
wire        hps_debug_reset;


// ------------------------------
// Display Port system clock
// ------------------------------
wire 		clk_270;
wire 		clk_cal_50;
wire 		clk_16;
wire 		clk_vid;
// ------------------------------
// Video Test Pattern Generator
// ------------------------------
wire [23:0] 	tpg_outd;
wire 	    	tpg_de;
wire 	    	tpg_h;
wire 	    	tpg_v;
// ----------------------
// Display Port
// ----------------------
wire          dp_tx_rcfg_req;
wire          dp_tx_rcfg_ack;
wire [7:0]    dp_tx_rcfg_vod;
wire [7:0]    dp_tx_rcfg_emp;
wire          dp_txpll_rcfg_req;
wire          dp_txpll_rcfg_ack;
wire          dp_tx_rcfg_busy;
wire [7:0]    dp_tx_link_rate_8bits;
wire          	xcvr_ctrl_txpll_powerdown;
wire [3:0]    	dp_tx_cal_busy;
wire [3:0]    	gxb_tx_clkout;
wire          	dp_txpll_locked;
wire [159:0] 	tx_parallel_data;
wire 			dp_tx_aux_aux_in;
wire 			dp_tx_aux_aux_out;
wire 			dp_tx_aux_aux_oe;

// -------------------------------
// XCVR FPLL
// -------------------------------
wire 			tx_pll_locked;
wire			tx_pll_cal_busy;
wire 			tx_pll_reconfig_write;
wire 			tx_pll_reconfig_read;
wire [9:0] 		tx_pll_reconfig_address;
wire [31:0] 	tx_pll_reconfig_writedata;
wire [31:0] 	tx_pll_reconfig_readdata;
wire 			tx_pll_reconfig_waitrequest;
// -------------------------------
// XCVR reconfiguration and reset
// -------------------------------
wire 			tx_gxb_reconfig_write;
wire			tx_gxb_reconfig_read;
wire [11:0] 	tx_gxb_reconfig_address;
wire [31:0] 	tx_gxb_reconfig_writedata;
wire [31:0] 	tx_gxb_reconfig_readdata;
wire 			tx_gxb_reconfig_waitrequest;

wire 		tx_xcvr_reset;
wire 		rx_cal_busy;
wire 		tx_cal_busy;
wire		tx_xcvr_busy;
wire		tx_xcvr_cal_busy;
wire [3:0] 	tx_analogreset;
wire [3:0] 	tx_digitalreset;
wire [3:0] 	gxb_tx_cal_busy;
wire [3:0] 	tx_ready;
wire [3:0] 	res_tx_cal_busy;
wire [3:0] 	tx_analogreset_ack;
wire [3:0] 	gxb_tx_coreclkin;
wire 		bitec_reconfig_reset;
wire 		xcvr_ctrl_reset; 
wire		tx_pll_mcgb_rst;

  
wire 		  	pr_handshake_start_req_ack_loopback_wire_0;
wire 		  	pr_handshake_stop_req_ack_loopback_wire_0;



// connection of internal logics
assign fpga_led_pio     = fpga_led_internal;
assign stm_hw_events    = {{16{1'b0}}, fpga_dipsw_pio, fpga_led_internal, fpga_debounced_buttons};


assign clk_270 			  = dp_refclk;
assign dp_on 			  = 1'b1;
assign rx_cal_busy 		  = 1'b0;
assign tx_cal_busy 		  = ~&tx_ready;
assign res_tx_cal_busy[0] = gxb_tx_cal_busy[0] | tx_pll_cal_busy;
assign res_tx_cal_busy[1] = gxb_tx_cal_busy[1] | tx_pll_cal_busy;
assign res_tx_cal_busy[2] = gxb_tx_cal_busy[2] | tx_pll_cal_busy;
assign res_tx_cal_busy[3] = gxb_tx_cal_busy[3] | tx_pll_cal_busy;
assign gxb_tx_coreclkin = {4{gxb_tx_clkout[0]}};
assign tx_xcvr_cal_busy = |gxb_tx_cal_busy;
assign bitec_reconfig_reset = hps_fpga_reset | ~fpga_reset_n;
assign xcvr_ctrl_reset = tx_xcvr_reset | hps_fpga_reset | ~fpga_reset_n;
assign tx_pll_mcgb_rst = hps_fpga_reset | ~fpga_reset_n;




// SoC sub-system module
ghrd_10as066n2 soc_inst (
.f2h_stm_hw_events_stm_hwevents                (stm_hw_events),                   
.pio_dipsw_external_connection_export          (fpga_dipsw_pio),    
.pio_led_external_connection_in_port           (fpga_led_internal),
.pio_led_external_connection_out_port          (fpga_led_internal),                   
.pio_button_external_connection_export         (fpga_debounced_buttons),    
.hps_io_hps_io_phery_emac0_TX_CLK              (hps_emac0_TX_CLK), 
.hps_io_hps_io_phery_emac0_TXD0                (hps_emac0_TXD0),   
.hps_io_hps_io_phery_emac0_TXD1                (hps_emac0_TXD1),   
.hps_io_hps_io_phery_emac0_TXD2                (hps_emac0_TXD2),   
.hps_io_hps_io_phery_emac0_TXD3                (hps_emac0_TXD3),   
.hps_io_hps_io_phery_emac0_MDIO                (hps_emac0_MDIO),   
.hps_io_hps_io_phery_emac0_MDC                 (hps_emac0_MDC),    
.hps_io_hps_io_phery_emac0_RX_CTL              (hps_emac0_RX_CTL), 
.hps_io_hps_io_phery_emac0_TX_CTL              (hps_emac0_TX_CTL), 
.hps_io_hps_io_phery_emac0_RX_CLK              (hps_emac0_RX_CLK), 
.hps_io_hps_io_phery_emac0_RXD0                (hps_emac0_RXD0),   
.hps_io_hps_io_phery_emac0_RXD1                (hps_emac0_RXD1),   
.hps_io_hps_io_phery_emac0_RXD2                (hps_emac0_RXD2),   
.hps_io_hps_io_phery_emac0_RXD3                (hps_emac0_RXD3),
.hps_io_hps_io_phery_usb0_DATA0                (hps_usb0_D0),      
.hps_io_hps_io_phery_usb0_DATA1                (hps_usb0_D1),      
.hps_io_hps_io_phery_usb0_DATA2                (hps_usb0_D2),      
.hps_io_hps_io_phery_usb0_DATA3                (hps_usb0_D3),      
.hps_io_hps_io_phery_usb0_DATA4                (hps_usb0_D4),      
.hps_io_hps_io_phery_usb0_DATA5                (hps_usb0_D5),      
.hps_io_hps_io_phery_usb0_DATA6                (hps_usb0_D6),      
.hps_io_hps_io_phery_usb0_DATA7                (hps_usb0_D7),      
.hps_io_hps_io_phery_usb0_CLK                  (hps_usb0_CLK),     
.hps_io_hps_io_phery_usb0_STP                  (hps_usb0_STP),     
.hps_io_hps_io_phery_usb0_DIR                  (hps_usb0_DIR),     
.hps_io_hps_io_phery_usb0_NXT                  (hps_usb0_NXT),   
.hps_io_hps_io_phery_spim1_CLK                 (hps_spim1_CLK),
.hps_io_hps_io_phery_spim1_MOSI                (hps_spim1_MOSI),
.hps_io_hps_io_phery_spim1_MISO                (hps_spim1_MISO),
.hps_io_hps_io_phery_spim1_SS0_N               (hps_spim1_SS0_N),
.hps_io_hps_io_phery_spim1_SS1_N               (hps_spim1_SS1_N),
.hps_io_hps_io_phery_uart1_RX                  (hps_uart1_RX),     
.hps_io_hps_io_phery_uart1_TX                  (hps_uart1_TX),  
.hps_io_hps_io_phery_sdmmc_CMD                 (hps_sdio_CMD),     
.hps_io_hps_io_phery_sdmmc_D0                  (hps_sdio_D0),      
.hps_io_hps_io_phery_sdmmc_D1                  (hps_sdio_D1),      
.hps_io_hps_io_phery_sdmmc_D2                  (hps_sdio_D2),      
.hps_io_hps_io_phery_sdmmc_D3                  (hps_sdio_D3),      
.hps_io_hps_io_phery_sdmmc_D4                  (hps_sdio_D4),
.hps_io_hps_io_phery_sdmmc_D5                  (hps_sdio_D5),
.hps_io_hps_io_phery_sdmmc_D6                  (hps_sdio_D6),
.hps_io_hps_io_phery_sdmmc_D7                  (hps_sdio_D7),
.hps_io_hps_io_phery_sdmmc_CCLK                (hps_sdio_CLK),   
.hps_io_hps_io_phery_trace_CLK                 (hps_trace_CLK),
.hps_io_hps_io_phery_trace_D0                  (hps_trace_D0),
.hps_io_hps_io_phery_trace_D1                  (hps_trace_D1),
.hps_io_hps_io_phery_trace_D2                  (hps_trace_D2),
.hps_io_hps_io_phery_trace_D3                  (hps_trace_D3),
.emif_a10_hps_0_mem_conduit_end_mem_ck         (hps_memory_mem_ck),     
.emif_a10_hps_0_mem_conduit_end_mem_ck_n       (hps_memory_mem_ck_n),   
.emif_a10_hps_0_mem_conduit_end_mem_a          (hps_memory_mem_a),      
.emif_a10_hps_0_mem_conduit_end_mem_act_n      (hps_memory_mem_act_n),
.emif_a10_hps_0_mem_conduit_end_mem_ba         (hps_memory_mem_ba), 
.emif_a10_hps_0_mem_conduit_end_mem_bg         (hps_memory_mem_bg),
.emif_a10_hps_0_mem_conduit_end_mem_cke        (hps_memory_mem_cke),    
.emif_a10_hps_0_mem_conduit_end_mem_cs_n       (hps_memory_mem_cs_n),   
.emif_a10_hps_0_mem_conduit_end_mem_odt        (hps_memory_mem_odt),    
.emif_a10_hps_0_mem_conduit_end_mem_reset_n    (hps_memory_mem_reset_n),
.emif_a10_hps_0_mem_conduit_end_mem_par        (hps_memory_mem_par), 
.emif_a10_hps_0_mem_conduit_end_mem_alert_n    (hps_memory_mem_alert_n), 
.emif_a10_hps_0_mem_conduit_end_mem_dqs        (hps_memory_mem_dqs),    
.emif_a10_hps_0_mem_conduit_end_mem_dqs_n      (hps_memory_mem_dqs_n),  
.emif_a10_hps_0_mem_conduit_end_mem_dq         (hps_memory_mem_dq), 
.emif_a10_hps_0_mem_conduit_end_mem_dbi_n      (hps_memory_mem_dbi_n), 
.emif_a10_hps_0_oct_conduit_end_oct_rzqin      (hps_memory_oct_rzqin), 
.emif_a10_hps_0_pll_ref_clk_clock_sink_clk     (emif_ref_clk),
.hps_io_hps_io_gpio_gpio1_io5                  (hps_gpio_GPIO05),  
.hps_io_hps_io_gpio_gpio1_io14                 (hps_gpio_GPIO14),
.hps_io_hps_io_gpio_gpio1_io16                 (hps_gpio_GPIO16),
.hps_io_hps_io_gpio_gpio1_io17                 (hps_gpio_GPIO17),
.hps_io_hps_io_phery_i2c1_SDA                  (hps_i2c1_SDA),
.hps_io_hps_io_phery_i2c1_SCL                  (hps_i2c1_SCL),  
.display_port_video_pll_locked_export       		   	(video_pll_locked),                                      
.display_port_video_pll_outclk0_clk          		   	(clk_vid),                                        
.display_port_video_pll_outclk1_clk          		   	(clk_16),                                     
.display_port_video_pll_outclk2_clk          		   	(clk_cal_50),
.display_port_clk_vip_clk           			   		(clk_vid),
.display_port_clk_16_clk                 		   		(clk_16),

.display_port_bitec_dp_0_clk_cal_clk     		   	  				(clk_cal_50),
.display_port_bitec_dp_0_tx_aux_aux_in       			  			(dp_tx_aux_aux_in),
.display_port_bitec_dp_0_tx_aux_aux_out      			  			(dp_tx_aux_aux_out),
.display_port_bitec_dp_0_tx_aux_aux_oe       			  			(dp_tx_aux_aux_oe),  
.display_port_bitec_dp_0_tx_aux_hpd          			 			(tx_hpd),

.display_port_bitec_dp_0_tx_analog_reconfig_analog_reconfig_req   	(dp_tx_rcfg_req),  
.display_port_bitec_dp_0_tx_analog_reconfig_analog_reconfig_ack   	(1'b1),
.display_port_bitec_dp_0_tx_analog_reconfig_analog_reconfig_busy  	(dp_tx_rcfg_busy),
.display_port_bitec_dp_0_tx_analog_reconfig_vod 		  			(dp_tx_rcfg_vod),
.display_port_bitec_dp_0_tx_analog_reconfig_emp 		  			(dp_tx_rcfg_emp),
.display_port_bitec_dp_0_tx_reconfig_link_rate            			(),
.display_port_bitec_dp_0_tx_reconfig_link_rate_8bits 		  		(dp_tx_link_rate_8bits),                          
.display_port_bitec_dp_0_tx_reconfig_reconfig_req		  			(dp_txpll_rcfg_req),                         
.display_port_bitec_dp_0_tx_reconfig_reconfig_ack		  			(1'b1),                             
.display_port_bitec_dp_0_tx_reconfig_reconfig_busy 	 	  			(dp_tx_rcfg_busy), 
.display_port_bitec_dp_0_tx_parallel_data              		  		(tx_parallel_data),
.display_port_bitec_dp_0_tx_pll_powerdown							(), 
.display_port_bitec_dp_0_tx_analogreset								(),                                   
.display_port_bitec_dp_0_tx_digitalreset							(),   
.display_port_bitec_dp_0_tx_cal_busy								({4{tx_cal_busy}}),
.display_port_bitec_dp_0_tx_std_clkout           		 			(gxb_tx_clkout),
.display_port_bitec_dp_0_tx_pll_locked            		  			(tx_pll_locked),  
 
.display_port_bitec_dp_0_tx0_video_in_1_clk      		  			(clk_vid),
.display_port_bitec_dp_0_tx0_video_in_data     			  			(tpg_outd),
.display_port_bitec_dp_0_tx0_video_in_v_sync    		 	 		(~tpg_v), 
.display_port_bitec_dp_0_tx0_video_in_h_sync    		  			(~tpg_h),   
.display_port_bitec_dp_0_tx0_video_in_de       			  			(tpg_de),

.display_port_pio_0_external_connection_export   		(),

.display_port_cvo_clocked_video_vid_clk        			(clk_vid),
.display_port_cvo_clocked_video_vid_data      			(tpg_outd),
.display_port_cvo_clocked_video_vid_datavalid  			(tpg_de),
.display_port_cvo_clocked_video_vid_v_sync     			(tpg_v),
.display_port_cvo_clocked_video_vid_h_sync     			(tpg_h),

.display_port_fpll_0_mcgb_rst_mcgb_rst 			(tx_pll_mcgb_rst),        
.display_port_fpll_0_pll_cal_busy_pll_cal_busy 	(tx_pll_cal_busy),                      
.display_port_fpll_0_pll_locked_pll_locked 		(tx_pll_locked),                         
.display_port_fpll_0_pll_refclk0_clk 				(clk_270),                                
.display_port_fpll_0_reconfig_avmm0_write 			(tx_pll_reconfig_write),                          
.display_port_fpll_0_reconfig_avmm0_read 			(tx_pll_reconfig_read),                            
.display_port_fpll_0_reconfig_avmm0_address 		(tx_pll_reconfig_address),                     
.display_port_fpll_0_reconfig_avmm0_writedata 		(tx_pll_reconfig_writedata),                      
.display_port_fpll_0_reconfig_avmm0_readdata 		(tx_pll_reconfig_readdata),                      
.display_port_fpll_0_reconfig_avmm0_waitrequest 	(tx_pll_reconfig_waitrequest),                
.display_port_fpll_0_tx_serial_clk_clk 			(),                            

.display_port_a10_xcvr_reconfig_avmm_ch0_write				(tx_gxb_reconfig_write),                        
.display_port_a10_xcvr_reconfig_avmm_ch0_read				(tx_gxb_reconfig_read),                         
.display_port_a10_xcvr_reconfig_avmm_ch0_address			(tx_gxb_reconfig_address),                      
.display_port_a10_xcvr_reconfig_avmm_ch0_writedata			(tx_gxb_reconfig_writedata),                     
.display_port_a10_xcvr_reconfig_avmm_ch0_readdata			(tx_gxb_reconfig_readdata), 
.display_port_a10_xcvr_reconfig_avmm_ch0_waitrequest			(tx_gxb_reconfig_waitrequest),   
.display_port_a10_xcvr_unused_tx_parallel_data_unused_tx_parallel_data (),
.display_port_a10_xcvr_tx_parallel_data_ch0_tx_parallel_data		(tx_parallel_data[39:0]),              
.display_port_a10_xcvr_tx_clkout_ch0_clk							(gxb_tx_clkout[0]),  
.display_port_a10_xcvr_tx_analogreset_ch0_tx_analogreset 			(tx_analogreset[0]),              
.display_port_a10_xcvr_tx_analogreset_ack_ch0_tx_analogreset_ack 	(tx_analogreset_ack[0]),  
.display_port_a10_xcvr_tx_cal_busy_ch0_tx_cal_busy 					(gxb_tx_cal_busy[0]),  
.display_port_a10_xcvr_tx_coreclkin_ch0_clk 						(gxb_tx_coreclkin[0]),                                            
.display_port_a10_xcvr_tx_digitalreset_ch0_tx_digitalreset 			(tx_digitalreset[0]),                        
.display_port_a10_xcvr_tx_polinv_ch0_tx_polinv						(1'b0),                        
.display_port_a10_xcvr_tx_serial_data_ch0_tx_serial_data 			(dp_tx_serial_out[0]),                    
.display_port_a10_xcvr_tx_parallel_data_ch1_tx_parallel_data		(tx_parallel_data[79:40]),              
.display_port_a10_xcvr_tx_clkout_ch1_clk							(gxb_tx_clkout[1]),  
.display_port_a10_xcvr_tx_analogreset_ch1_tx_analogreset 			(tx_analogreset[1]),              
.display_port_a10_xcvr_tx_analogreset_ack_ch1_tx_analogreset_ack 	(tx_analogreset_ack[1]),  
.display_port_a10_xcvr_tx_cal_busy_ch1_tx_cal_busy 					(gxb_tx_cal_busy[1]),  
.display_port_a10_xcvr_tx_coreclkin_ch1_clk 						(gxb_tx_coreclkin[1]),                                            
.display_port_a10_xcvr_tx_digitalreset_ch1_tx_digitalreset 			(tx_digitalreset[1]),                        
.display_port_a10_xcvr_tx_polinv_ch1_tx_polinv						(1'b0),                        
.display_port_a10_xcvr_tx_serial_data_ch1_tx_serial_data 			(dp_tx_serial_out[1]),                    
.display_port_a10_xcvr_tx_parallel_data_ch2_tx_parallel_data		(tx_parallel_data[119:80]),              
.display_port_a10_xcvr_tx_clkout_ch2_clk							(gxb_tx_clkout[2]),  
.display_port_a10_xcvr_tx_analogreset_ch2_tx_analogreset 			(tx_analogreset[2]),              
.display_port_a10_xcvr_tx_analogreset_ack_ch2_tx_analogreset_ack 	(tx_analogreset_ack[2]),  
.display_port_a10_xcvr_tx_cal_busy_ch2_tx_cal_busy 					(gxb_tx_cal_busy[2]),  
.display_port_a10_xcvr_tx_coreclkin_ch2_clk 						(gxb_tx_coreclkin[2]),                                            
.display_port_a10_xcvr_tx_digitalreset_ch2_tx_digitalreset 			(tx_digitalreset[2]),                        
.display_port_a10_xcvr_tx_polinv_ch2_tx_polinv						(1'b0),                        
.display_port_a10_xcvr_tx_serial_data_ch2_tx_serial_data 			(dp_tx_serial_out[2]),                    
.display_port_a10_xcvr_tx_parallel_data_ch3_tx_parallel_data		(tx_parallel_data[159:120]),              
.display_port_a10_xcvr_tx_clkout_ch3_clk							(gxb_tx_clkout[3]),  
.display_port_a10_xcvr_tx_analogreset_ch3_tx_analogreset 			(tx_analogreset[3]),              
.display_port_a10_xcvr_tx_analogreset_ack_ch3_tx_analogreset_ack 	(tx_analogreset_ack[3]),  
.display_port_a10_xcvr_tx_cal_busy_ch3_tx_cal_busy 					(gxb_tx_cal_busy[3]),  
.display_port_a10_xcvr_tx_coreclkin_ch3_clk 						(gxb_tx_coreclkin[3]),                                            
.display_port_a10_xcvr_tx_digitalreset_ch3_tx_digitalreset 			(tx_digitalreset[3]),                        
.display_port_a10_xcvr_tx_polinv_ch3_tx_polinv						(1'b0),                        
.display_port_a10_xcvr_tx_serial_data_ch3_tx_serial_data 			(dp_tx_serial_out[3]),                    
.display_port_xcvr_ctrl_pll_locked_pll_locked 			(tx_pll_locked),                   
.display_port_xcvr_ctrl_pll_select_pll_select			(1'b0),        
.display_port_xcvr_ctrl_reset_reset 						(xcvr_ctrl_reset),           
.display_port_xcvr_ctrl_tx_analogreset_tx_analogreset 	(tx_analogreset),                
.display_port_xcvr_ctrl_tx_cal_busy_tx_cal_busy 			(res_tx_cal_busy),                    
.display_port_xcvr_ctrl_tx_digitalreset_tx_digitalreset 	(tx_digitalreset),              
.display_port_xcvr_ctrl_tx_ready_tx_ready 				(tx_ready),                           
.frz_ctrl_0_pr_handshake_start_req	 		(pr_handshake_start_req_ack_loopback_wire_0),
.frz_ctrl_0_pr_handshake_start_ack	 		(pr_handshake_start_req_ack_loopback_wire_0), 
.frz_ctrl_0_pr_handshake_stop_req	 		(pr_handshake_stop_req_ack_loopback_wire_0),
.frz_ctrl_0_pr_handshake_stop_ack	 		(pr_handshake_stop_req_ack_loopback_wire_0),
.hps_fpga_reset_reset                          (hps_fpga_reset),
.issp_hps_resets_source                        (hps_reset_req),
.f2h_cold_reset_req_reset_n                    (~hps_cold_reset),
.f2h_warm_reset_req_reset_n                    (~hps_warm_reset),
.f2h_debug_reset_req_reset_n                   (~hps_debug_reset),
.reset_reset_n                                 (fpga_reset_n),
.clk_100_clk                                   (fpga_clk_100)
);  

bitec_reconfig_alt_a10 bitec_reconfig_alt_a10_i (
.clk                    	(fpga_clk_100),
.reset                  	(bitec_reconfig_reset),
.tx_analogreset_ack     	(&tx_analogreset_ack),

.rx_link_rate           	(8'd0),
.rx_link_rate_strobe    	(1'b0),
.rx_xcvr_busy           	(),

.tx_link_rate           	(dp_tx_link_rate_8bits),
.tx_vod                 	(dp_tx_rcfg_vod),
.tx_emp                 	(dp_tx_rcfg_emp),
.tx_link_rate_strobe    	(dp_txpll_rcfg_req),
.tx_vodemp_strobe       	(dp_tx_rcfg_req),
.tx_xcvr_busy           	(dp_tx_rcfg_busy),
.tx_xcvr_reset          	(tx_xcvr_reset),

.rx_analogreset_ack     	(1'b0),
.rx_mgmt_readdata       	(32'd0),
.rx_mgmt_waitrequest    	(1'b0), 

.tx_mgmt_chnum             	(tx_gxb_reconfig_address[11:10]),
.tx_mgmt_address          	(tx_gxb_reconfig_address[9:0]),
.tx_mgmt_writedata         	(tx_gxb_reconfig_writedata),
.tx_mgmt_readdata          	(tx_gxb_reconfig_readdata),
.tx_mgmt_write            	(tx_gxb_reconfig_write),
.tx_mgmt_read              	(tx_gxb_reconfig_read),
.tx_mgmt_waitrequest       	(tx_gxb_reconfig_waitrequest),

.txpll_mgmt_address       	(tx_pll_reconfig_address),
.txpll_mgmt_writedata     	(tx_pll_reconfig_writedata),
.txpll_mgmt_readdata      	(tx_pll_reconfig_readdata),
.txpll_mgmt_write         	(tx_pll_reconfig_write),
.txpll_mgmt_read          	(tx_pll_reconfig_read),
.txpll_mgmt_waitrequest   	(tx_pll_reconfig_waitrequest),  

.rx_xcvr_cal_busy          		(rx_cal_busy),
.tx_xcvr_cal_busy				(tx_xcvr_cal_busy),
.tx_pll_cal_busy				(tx_pll_cal_busy)
);

defparam  bitec_reconfig_alt_a10_i.RX_LANES = 0;
defparam  bitec_reconfig_alt_a10_i.TX_LANES = 4;
defparam  bitec_reconfig_alt_a10_i.TX_RATES_NUM = 3;
defparam  bitec_reconfig_alt_a10_i.RX_RATES_NUM = 0;


// Instantiate the AUX buffers
buslvds buslvds_i (
.doutp		(dp_tx_aux_aux_out),
.oe		(dp_tx_aux_aux_oe),
.din		(dp_tx_aux_aux_in),
.p		(dp_aux_ch_p),
.n		(dp_aux_ch_n)
);



// Debounce logic to clean out glitches within 1ms
debounce debounce_inst (
.clk                                  (fpga_clk_100),
.reset_n                              (~hps_fpga_reset), 
.data_in                              (fpga_button_pio),
.data_out                             (fpga_debounced_buttons)
);
defparam debounce_inst.WIDTH = 4;
defparam debounce_inst.POLARITY = "LOW";
defparam debounce_inst.TIMEOUT = 100000;              // at 100Mhz this is a debounce time of 1ms
defparam debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

altera_edge_detector pulse_cold_reset (
.clk       (fpga_clk_100),
.rst_n     (~hps_fpga_reset),
.signal_in (hps_reset_req[0]),
.pulse_out (hps_cold_reset)
);
defparam pulse_cold_reset.PULSE_EXT = 6;
defparam pulse_cold_reset.EDGE_TYPE = 1;
defparam pulse_cold_reset.IGNORE_RST_WHILE_BUSY = 1;

altera_edge_detector pulse_warm_reset (
.clk       (fpga_clk_100),
.rst_n     (~hps_fpga_reset),
.signal_in (hps_reset_req[1]),
.pulse_out (hps_warm_reset)
);
defparam pulse_warm_reset.PULSE_EXT = 2;
defparam pulse_warm_reset.EDGE_TYPE = 1;
defparam pulse_warm_reset.IGNORE_RST_WHILE_BUSY = 1;

altera_edge_detector pulse_debug_reset (
.clk       (fpga_clk_100),
.rst_n     (~hps_fpga_reset),
.signal_in (hps_reset_req[2]),
.pulse_out (hps_debug_reset)
);
defparam pulse_debug_reset.PULSE_EXT = 32;
defparam pulse_debug_reset.EDGE_TYPE = 1;
defparam pulse_debug_reset.IGNORE_RST_WHILE_BUSY = 1;

endmodule


