package altera_xcvr_native_a10_reconfig_parameters;

localparam ram_depth = 27;
function [25:0] get_ram_data;
  input integer index;
  automatic reg [0:26][25:0] ram_data = {
    26'h006DF02, // [25:16]-DPRIO address=0x006; [15:8]-bit mask=0xDF; [7:7]-hssi_tx_pcs_pma_interface_sqwgen_clken=sqwgen_clk_dis(1'h0); [6:6]-hssi_tx_pcs_pma_interface_prbs_clken=prbs_clk_dis(1'h0); [4:4]-hssi_tx_pcs_pma_interface_master_clk_sel=master_tx_pma_clk(1'h0); [3:3]-hssi_tx_pcs_pma_interface_prbs9_dwidth=prbs9_64b(1'h0); [2:0]-hssi_tx_pcs_pma_interface_tx_pma_data_sel=eight_g_pcs(3'h2);
    26'h007FF09, // [25:16]-DPRIO address=0x007; [15:8]-bit mask=0xFF; [7:4]-hssi_tx_pcs_pma_interface_prbs_gen_pat=prbs_gen_dis(4'h0); [3:3]-hssi_tx_pcs_pma_interface_tx_dyn_polarity_inversion=tx_dyn_polinv_en(1'h1); [2:2]-hssi_tx_pcs_pma_interface_tx_static_polarity_inversion=tx_stat_polinv_dis(1'h0); [1:1]-hssi_tx_pcs_pma_interface_pmagate_en=pmagate_dis(1'h0); [0:0]-hssi_tx_pcs_pma_interface_bypass_pma_txelecidle=true(1'h1);
    26'h008FF04, // [25:16]-DPRIO address=0x008; [15:8]-bit mask=0xFF; [7:7]-hssi_tx_pcs_pma_interface_pldif_datawidth_mode=pldif_data_10bit(1'h0); [6:5]-hssi_tx_pcs_pma_interface_tx_pma_data_sel=eight_g_pcs(2'h0); [4:4]-hssi_tx_pcs_pma_interface_prbs_gen_pat=prbs_gen_dis(1'h0); [3:0]-hssi_tx_pcs_pma_interface_sq_wave_num=sq_wave_default(4'h4);
    26'h00F1000, // [25:16]-DPRIO address=0x00F; [15:8]-bit mask=0x10; [4:4]-hssi_tx_pcs_pma_interface_pma_if_dft_en=dft_dis(1'h0);
    26'h0207E04, // [25:16]-DPRIO address=0x020; [15:8]-bit mask=0x7E; [6:6]-hssi_tx_pld_pcs_interface_pcs_tx_delay2_clk_en=delay2_clk_disable(1'h0); [5:5]-hssi_tx_pld_pcs_interface_pcs_tx_delay1_clk_en=delay1_clk_disable(1'h0); [4:4]-hssi_tx_pld_pcs_interface_pcs_tx_delay1_data_sel=one_ff_delay(1'h0); [3:3]-hssi_tx_pld_pcs_interface_pcs_tx_output_sel=teng_output(1'h0); [2:2]-hssi_tx_pld_pcs_interface_pcs_tx_delay1_clk_sel=pcs_tx_clk(1'h1); [1:1]-hssi_tx_pld_pcs_interface_pcs_tx_data_source=hip_disable(1'h0);
    26'h021FF00, // [25:16]-DPRIO address=0x021; [15:8]-bit mask=0xFF; [7:4]-hssi_tx_pld_pcs_interface_pcs_tx_delay2_ctrl=delay2_path0(4'h0); [3:0]-hssi_tx_pld_pcs_interface_pcs_tx_delay1_ctrl=delay1_path0(4'h0);
    26'h0220F00, // [25:16]-DPRIO address=0x022; [15:8]-bit mask=0x0F; [3:2]-hssi_tx_pld_pcs_interface_pcs_tx_clk_source=eightg(2'h0); [1:0]-hssi_tx_pld_pcs_interface_pcs_tx_clk_out_sel=eightg_clk_out(2'h0);
    26'h02CFF30, // [25:16]-DPRIO address=0x02C; [15:8]-bit mask=0xFF; [7:7]-hssi_8g_tx_pcs_tx_fast_pld_reg=dis_tx_fast_pld_reg(1'h0); [6:6]-hssi_8g_tx_pcs_force_echar=dis_force_echar(1'h0); [5:5]-hssi_8g_tx_pcs_txpcs_urst=en_txpcs_urst(1'h1); [4:4]-hssi_8g_tx_pcs_txclk_freerun=en_freerun_tx(1'h1); [3:3]-hssi_8g_tx_pcs_phfifo_write_clk_sel=pld_tx_clk(1'h0); [2:2]-hssi_8g_tx_pcs_refclk_b_clk_sel=tx_pma_clock(1'h0); [1:0]-hssi_8g_tx_pcs_eightb_tenb_disp_ctrl=dis_disp_ctrl(2'h0);
    26'h02DFF31, // [25:16]-DPRIO address=0x02D; [15:8]-bit mask=0xFF; [7:7]-hssi_8g_tx_pcs_revloop_back_rm=dis_rev_loopback_rx_rm(1'h0); [6:5]-hssi_8g_tx_pcs_byte_serializer=en_bs_by_2(2'h1); [4:2]-hssi_8g_tx_pcs_phase_compensation_fifo=low_latency(3'h4); [1:0]-hssi_8g_tx_pcs_eightb_tenb_encoder=dis_8b10b(2'h1);
    26'h02EF900, // [25:16]-DPRIO address=0x02E; [15:8]-bit mask=0xF9; [7:7]-hssi_8g_tx_pcs_tx_bitslip=dis_tx_bitslip(1'h0); [6:6]-hssi_8g_tx_pcs_symbol_swap=dis_symbol_swap(1'h0); [5:5]-hssi_8g_tx_pcs_gen3_tx_pipe_clk_sel=dis_tx_pipe_clk(1'h0); [4:4]-hssi_8g_tx_pcs_bit_reversal=dis_bit_reversal(1'h0); [3:3]-hssi_8g_tx_pcs_pcs_bypass=dis_pcs_bypass(1'h0); [0:0]-hssi_8g_tx_pcs_clock_gate_bs_enc=dis_bs_enc_clk_gating(1'h0);
    26'h02F1F0E, // [25:16]-DPRIO address=0x02F; [15:8]-bit mask=0x1F; [4:4]-hssi_8g_tx_pcs_force_kchar=dis_force_kchar(1'h0); [3:1]-hssi_8g_tx_pcs_pma_dw=twenty_bit(3'h7); [0:0]-hssi_8g_tx_pcs_data_selection_8b10b_encoder_input=normal_data_path(1'h0);
    26'h0303F00, // [25:16]-DPRIO address=0x030; [15:8]-bit mask=0x3F; [5:5]-hssi_8g_tx_pcs_clock_gate_sw_fifowr=dis_sw_fifowr_clk_gating(1'h0); [4:4]-hssi_8g_tx_pcs_clock_gate_dw_fifowr=dis_dw_fifowr_clk_gating(1'h0); [3:3]-hssi_8g_tx_pcs_clock_gate_fiford=dis_fiford_clk_gating(1'h0); [2:2]-hssi_8g_tx_pcs_gen3_tx_clk_sel=dis_tx_clk(1'h0); [1:0]-hssi_8g_tx_pcs_tx_compliance_controlled_disparity=dis_txcompliance(2'h0);
    26'h031FF04, // [25:16]-DPRIO address=0x031; [15:8]-bit mask=0xFF; [7:5]-hssi_8g_tx_pcs_clock_observation_in_pld_core=internal_refclk_b(3'h0); [4:4]-hssi_8g_tx_pcs_bonding_dft_en=dft_dis(1'h0); [3:3]-hssi_8g_tx_pcs_bonding_dft_val=dft_0(1'h0); [2:2]-hssi_8g_tx_pcs_phase_comp_rdptr=enable_rdptr(1'h1); [1:1]-hssi_8g_tx_pcs_dynamic_clk_switch=dis_dyn_clk_switch(1'h0); [0:0]-hssi_8g_tx_pcs_bypass_pipeline_reg=dis_bypass_pipeline(1'h0);
    26'h05FFA00, // [25:16]-DPRIO address=0x05F; [15:8]-bit mask=0xFA; [7:3]-hssi_gen3_tx_pcs_tx_bitslip=0(5'h0); [1:1]-hssi_gen3_tx_pcs_reverse_lpbk=rev_lpbk_dis(1'h0);
    26'h0600101, // [25:16]-DPRIO address=0x060; [15:8]-bit mask=0x01; [0:0]-hssi_gen3_tx_pcs_tx_gbox_byp=bypass_gbox(1'h1);
    26'h068FB00, // [25:16]-DPRIO address=0x068; [15:8]-bit mask=0xFB; [7:7]-hssi_pipe_gen3_ind_error_reporting=dis_ind_error_reporting(1'h0); [6:6]-hssi_pipe_gen3_phystatus_rst_toggle_g12=dis_phystatus_rst_toggle(1'h0); [5:3]-hssi_pipe_gen3_phy_status_delay_g12=0(3'h0); [1:1]-hssi_pipe_gen3_bypass_rx_detection_enable=false(1'h0); [0:0]-hssi_pipe_gen3_rate_match_pad_insertion=dis_rm_fifo_pad_ins(1'h0);
    26'h069FC3C, // [25:16]-DPRIO address=0x069; [15:8]-bit mask=0xFC; [7:7]-hssi_pipe_gen3_bypass_rx_preset_enable=false(1'h0); [6:6]-hssi_pipe_gen3_bypass_tx_coefficent_enable=false(1'h0); [5:2]-hssi_pipe_gen3_test_out_sel=disable_test_out(4'hF);
    26'h06A7F00, // [25:16]-DPRIO address=0x06A; [15:8]-bit mask=0x7F; [6:6]-hssi_pipe_gen3_phystatus_rst_toggle_g3=dis_phystatus_rst_toggle_g3(1'h0); [5:3]-hssi_pipe_gen3_phy_status_delay_g3=0(3'h0); [2:0]-hssi_pipe_gen3_elecidle_delay_g3=0(3'h0);
    26'h06BFF00, // [25:16]-DPRIO address=0x06B; [15:8]-bit mask=0xFF; [7:0]-hssi_pipe_gen3_bypass_tx_coefficent=0(8'h0);
    26'h06CFF00, // [25:16]-DPRIO address=0x06C; [15:8]-bit mask=0xFF; [7:0]-hssi_pipe_gen3_bypass_tx_coefficent=0(8'h0);
    26'h06D1F00, // [25:16]-DPRIO address=0x06D; [15:8]-bit mask=0x1F; [4:2]-hssi_pipe_gen3_bypass_rx_preset=0(3'h0); [1:0]-hssi_pipe_gen3_bypass_tx_coefficent=0(2'h0);
    26'h0C50300, // [25:16]-DPRIO address=0x0C5; [15:8]-bit mask=0x03; [1:1]-hssi_fifo_tx_pcs_double_write_mode=double_write_dis(1'h0); [0:0]-hssi_fifo_tx_pcs_prot_mode=non_teng_mode(1'h0);
    26'h1058000, // [25:16]-DPRIO address=0x105; [15:8]-bit mask=0x80; [7:7]-pma_tx_buf_user_fir_coeff_ctrl_sel=ram_ctl(1'h0);
    26'h10D7E00, // [25:16]-DPRIO address=0x10D; [15:8]-bit mask=0x7E; [6:3]-pma_tx_buf_rx_det=mode_0(4'h0); [2:2]-pma_tx_buf_rx_det_pdb=rx_det_off(1'h0); [1:1]-pma_tx_buf_rx_det_output_sel=rx_det_pcie_out(1'h0);
    26'h1103F05, // [25:16]-DPRIO address=0x110; [15:8]-bit mask=0x3F; [5:3]-pma_tx_ser_ser_clk_divtx_user_sel=divtx_user_off(3'h0); [2:0]-pma_cgb_ser_mode=twenty_bit(3'h5);
    26'h1120400, // [25:16]-DPRIO address=0x112; [15:8]-bit mask=0x04; [2:2]-pma_cgb_bitslip_enable=disable_bitslip(1'h0);
    26'h1190E00  // [25:16]-DPRIO address=0x119; [15:8]-bit mask=0x0E; [3:2]-pma_cgb_x1_div_m_sel=divbypass(2'h0); [1:1]-pma_cgb_pcie_gen3_bitwidth=pciegen3_wide(1'h0);
};

  begin
  get_ram_data = ram_data[index];
  end
endfunction

localparam PLL_SELECT_VALUE = 0;

localparam HSSI_GEN3_TX_PCS_MODE_VALUE = "disable_pcs";

localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_VALUE = "rev_lpbk_dis";
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_OFST = 95;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_OFST = 1;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_HIGH = 1;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_SIZE = 1;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_GEN3_TX_PCS_REVERSE_LPBK_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_GEN3_TX_PCS_SUP_MODE_VALUE = "user_mode";

localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_VALUE = 5'd0;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_OFST = 95;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_OFST = 3;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_HIGH = 7;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_SIZE = 5;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_BITMASK = 32'h000000F8;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_GEN3_TX_PCS_TX_BITSLIP_ADDR_FIELD_VALUE = 5'h0;

localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_VALUE = "bypass_gbox";
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_OFST = 96;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_OFST = 0;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_HIGH = 0;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_SIZE = 1;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_VALMASK = 32'h00000001;
localparam HSSI_GEN3_TX_PCS_TX_GBOX_BYP_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_8G_TX_PCS_BIT_REVERSAL_VALUE = "dis_bit_reversal";
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_OFST = 4;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_BIT_REVERSAL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_VALUE = "dft_dis";
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_OFST = 4;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_BONDING_DFT_EN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_VALUE = "dft_0";
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_OFST = 3;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_HIGH = 3;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_BONDING_DFT_VAL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_VALUE = "dis_bypass_pipeline";
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_HIGH = 0;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_BYPASS_PIPELINE_REG_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_VALUE = "en_bs_by_2";
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_OFST = 45;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_OFST = 5;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_HIGH = 6;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_SIZE = 2;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_BITMASK = 32'h00000060;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_VALMASK = 32'h00000020;
localparam HSSI_8G_TX_PCS_BYTE_SERIALIZER_ADDR_FIELD_VALUE = 2'h1;

localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_VALUE = "dis_bs_enc_clk_gating";
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_HIGH = 0;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_BS_ENC_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_VALUE = "dis_dw_fifowr_clk_gating";
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_OFST = 48;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_OFST = 4;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_DW_FIFOWR_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_VALUE = "dis_fiford_clk_gating";
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_OFST = 48;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_OFST = 3;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_HIGH = 3;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_FIFORD_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_VALUE = "dis_sw_fifowr_clk_gating";
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_OFST = 48;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_OFST = 5;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_HIGH = 5;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_BITMASK = 32'h00000020;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_CLOCK_GATE_SW_FIFOWR_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_VALUE = "internal_refclk_b";
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_OFST = 5;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_HIGH = 7;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_SIZE = 3;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_BITMASK = 32'h000000E0;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_CLOCK_OBSERVATION_IN_PLD_CORE_ADDR_FIELD_VALUE = 3'h0;

localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_VALUE = "normal_data_path";
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_OFST = 47;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_HIGH = 0;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_DATA_SELECTION_8B10B_ENCODER_INPUT_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_VALUE = "dis_dyn_clk_switch";
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_OFST = 1;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_HIGH = 1;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_DYNAMIC_CLK_SWITCH_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_VALUE = "dis_disp_ctrl";
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_HIGH = 1;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_SIZE = 2;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_BITMASK = 32'h00000003;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_DISP_CTRL_ADDR_FIELD_VALUE = 2'h0;

localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_VALUE = "dis_8b10b";
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_OFST = 45;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_HIGH = 1;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_SIZE = 2;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_BITMASK = 32'h00000003;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_VALMASK = 32'h00000001;
localparam HSSI_8G_TX_PCS_EIGHTB_TENB_ENCODER_ADDR_FIELD_VALUE = 2'h1;

localparam HSSI_8G_TX_PCS_FORCE_ECHAR_VALUE = "dis_force_echar";
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_OFST = 6;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_HIGH = 6;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_FORCE_ECHAR_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_FORCE_KCHAR_VALUE = "dis_force_kchar";
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_OFST = 47;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_OFST = 4;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_FORCE_KCHAR_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_VALUE = "dis_tx_clk";
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_OFST = 48;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_OFST = 2;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_HIGH = 2;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000004;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_GEN3_TX_CLK_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_VALUE = "dis_tx_pipe_clk";
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_OFST = 5;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_HIGH = 5;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000020;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_GEN3_TX_PIPE_CLK_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_HIP_MODE_VALUE = "dis_hip";

localparam HSSI_8G_TX_PCS_PCS_BYPASS_VALUE = "dis_pcs_bypass";
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_OFST = 3;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_HIGH = 3;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_PCS_BYPASS_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_VALUE = "enable_rdptr";
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_OFST = 49;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_OFST = 2;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_HIGH = 2;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_BITMASK = 32'h00000004;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_VALMASK = 32'h00000004;
localparam HSSI_8G_TX_PCS_PHASE_COMP_RDPTR_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_VALUE = "low_latency";
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_OFST = 45;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_OFST = 2;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_SIZE = 3;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_BITMASK = 32'h0000001C;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_VALMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_PHASE_COMPENSATION_FIFO_ADDR_FIELD_VALUE = 3'h4;

localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_VALUE = "pld_tx_clk";
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_OFST = 3;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_HIGH = 3;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_PHFIFO_WRITE_CLK_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_PMA_DW_VALUE = "twenty_bit";
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_OFST = 47;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_OFST = 1;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_HIGH = 3;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_SIZE = 3;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_BITMASK = 32'h0000000E;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_VALMASK = 32'h0000000E;
localparam HSSI_8G_TX_PCS_PMA_DW_ADDR_FIELD_VALUE = 3'h7;

localparam HSSI_8G_TX_PCS_PROT_MODE_VALUE = "basic";

localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_VALUE = "tx_pma_clock";
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_OFST = 2;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_HIGH = 2;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000004;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_REFCLK_B_CLK_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_VALUE = "dis_rev_loopback_rx_rm";
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_OFST = 45;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_OFST = 7;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_HIGH = 7;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_REVLOOP_BACK_RM_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_SUP_MODE_VALUE = "user_mode";

localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_VALUE = "dis_symbol_swap";
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_OFST = 6;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_HIGH = 6;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_SYMBOL_SWAP_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_TX_BITSLIP_VALUE = "dis_tx_bitslip";
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_OFST = 46;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_OFST = 7;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_HIGH = 7;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_TX_BITSLIP_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_VALUE = "dis_txcompliance";
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_OFST = 48;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_OFST = 0;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_HIGH = 1;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_SIZE = 2;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_BITMASK = 32'h00000003;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_TX_COMPLIANCE_CONTROLLED_DISPARITY_ADDR_FIELD_VALUE = 2'h0;

localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_VALUE = "dis_tx_fast_pld_reg";
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_OFST = 7;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_HIGH = 7;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_8G_TX_PCS_TX_FAST_PLD_REG_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_VALUE = "en_freerun_tx";
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_OFST = 4;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_HIGH = 4;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_VALMASK = 32'h00000010;
localparam HSSI_8G_TX_PCS_TXCLK_FREERUN_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_8G_TX_PCS_TXPCS_URST_VALUE = "en_txpcs_urst";
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_OFST = 44;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_OFST = 5;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_HIGH = 5;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_SIZE = 1;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_BITMASK = 32'h00000020;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_VALMASK = 32'h00000020;
localparam HSSI_8G_TX_PCS_TXPCS_URST_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_8G_TX_PCS_RECONFIG_SETTINGS_VALUE = "{}";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_HIP_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_HRDRSTCTL_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_PROT_MODE_TX_VALUE = "basic_8gpcs_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_CTRL_PLANE_BONDING_TX_VALUE = "individual_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_PMA_DW_TX_VALUE = "pma_20b_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_PLD_FIFO_MODE_TX_VALUE = "fifo_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_SHARED_FIFO_WIDTH_TX_VALUE = "single_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_LOW_LATENCY_EN_TX_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_FUNC_MODE_VALUE = "enable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_FREQUENCY_RULES_EN_VALUE = "enable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_PMA_TX_CLK_HZ_VALUE = 30'd270000000;

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_CHNL_PLD_TX_CLK_HZ_VALUE = 30'd135000000;

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_FIFO_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_FIFO_PROT_MODE_TX_VALUE = "non_teng_mode_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_FIFO_SHARED_FIFO_WIDTH_TX_VALUE = "single_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_ADVANCED_USER_MODE_TX_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_PMA_DW_TX_VALUE = "pma_64b_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_FIFO_MODE_TX_VALUE = "fifo_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_PROT_MODE_TX_VALUE = "disabled_prot_mode_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_LOW_LATENCY_EN_TX_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_10G_SHARED_FIFO_WIDTH_TX_VALUE = "single_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_PROT_MODE_TX_VALUE = "basic_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_HIP_MODE_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_PMA_DW_TX_VALUE = "pma_20b_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_8G_FIFO_MODE_TX_VALUE = "fifo_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_G3_PROT_MODE_VALUE = "disabled_prot_mode";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_KRFEC_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_KRFEC_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_KRFEC_PROT_MODE_TX_VALUE = "disabled_prot_mode_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_KRFEC_LOW_LATENCY_EN_TX_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PMAIF_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PMAIF_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PMAIF_SIM_MODE_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PMAIF_PROT_MODE_TX_VALUE = "eightg_basic_mode_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PMAIF_PMA_DW_TX_VALUE = "pma_20b_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PLDIF_PROT_MODE_TX_VALUE = "eightg_and_g3_pld_fifo_mode_tx";

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PLDIF_HRDRSTCTL_EN_VALUE = "disable";

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_VALUE = "eightg";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_OFST = 34;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_OFST = 2;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_SIZE = 2;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_SOURCE_ADDR_FIELD_VALUE = 2'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_VALUE = "hip_disable";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_OFST = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_HIGH = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DATA_SOURCE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_VALUE = "delay1_clk_disable";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_OFST = 5;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_HIGH = 5;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_BITMASK = 32'h00000020;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_EN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_VALUE = "pcs_tx_clk";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_OFST = 2;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_HIGH = 2;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000004;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000004;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CLK_SEL_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_VALUE = "delay1_path0";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_OFST = 33;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_OFST = 0;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_SIZE = 4;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_BITMASK = 32'h0000000F;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_CTRL_ADDR_FIELD_VALUE = 4'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_VALUE = "one_ff_delay";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_OFST = 4;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_HIGH = 4;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY1_DATA_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_VALUE = "delay2_clk_disable";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_OFST = 6;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_HIGH = 6;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CLK_EN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_VALUE = "delay2_path0";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_OFST = 33;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_OFST = 4;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_HIGH = 7;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_SIZE = 4;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_BITMASK = 32'h000000F0;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_DELAY2_CTRL_ADDR_FIELD_VALUE = 4'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_VALUE = "teng_output";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_OFST = 32;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_OFST = 3;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_OUTPUT_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_VALUE = "eightg_clk_out";
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_OFST = 34;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_OFST = 0;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_HIGH = 1;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_SIZE = 2;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_BITMASK = 32'h00000003;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PLD_PCS_INTERFACE_PCS_TX_CLK_OUT_SEL_ADDR_FIELD_VALUE = 2'h0;

localparam HSSI_TX_PLD_PCS_INTERFACE_RECONFIG_SETTINGS_VALUE = "{}";

localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_VALUE = "true";
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_OFST = 0;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_HIGH = 0;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_VALMASK = 32'h00000001;
localparam HSSI_TX_PCS_PMA_INTERFACE_BYPASS_PMA_TXELECIDLE_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_TX_PCS_PMA_INTERFACE_CHANNEL_OPERATION_MODE_VALUE = "tx_rx_independent";

localparam HSSI_TX_PCS_PMA_INTERFACE_LPBK_EN_VALUE = "disable";

localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_VALUE = "master_tx_pma_clk";
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_OFST = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_HIGH = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_MASTER_CLK_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PCIE_SUB_PROT_MODE_TX_VALUE = "other_prot_mode";

localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_VALUE = "pldif_data_10bit";
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_OFST = 8;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_HIGH = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PLDIF_DATAWIDTH_MODE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_DW_TX_VALUE = "pma_20b_tx";

localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_VALUE = "dft_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_OFST = 15;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_OFST = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_HIGH = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_BITMASK = 32'h00000010;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMA_IF_DFT_EN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_VALUE = "pmagate_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_OFST = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_HIGH = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PMAGATE_EN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_VALUE = "prbs_clk_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_HIGH = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_CLKEN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_VALUE = "prbs_gen_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_OFST = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_HIGH = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_SIZE = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_BITMASK = 32'h000000F0;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR0_FIELD_VALUE = 4'h0;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_OFST = 8;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_OFST = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_HIGH = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_BITMASK = 32'h00000010;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS_GEN_PAT_ADDR1_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_VALUE = "prbs9_64b";
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_OFST = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_PRBS9_DWIDTH_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_PROT_MODE_TX_VALUE = "eightg_basic_mode_tx";

localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_VALUE = "sq_wave_default";
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_OFST = 8;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_OFST = 0;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_SIZE = 4;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_BITMASK = 32'h0000000F;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_VALMASK = 32'h00000004;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQ_WAVE_NUM_ADDR_FIELD_VALUE = 4'h4;

localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_VALUE = "sqwgen_clk_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_HIGH = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_SQWGEN_CLKEN_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_SUP_MODE_VALUE = "user_mode";

localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_VALUE = "tx_dyn_polinv_en";
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_OFST = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_HIGH = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_BITMASK = 32'h00000008;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_VALMASK = 32'h00000008;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_DYN_POLARITY_INVERSION_ADDR_FIELD_VALUE = 1'h1;

localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_VALUE = "eight_g_pcs";
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_OFST = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_OFST = 0;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_HIGH = 2;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_SIZE = 3;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_BITMASK = 32'h00000007;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_VALMASK = 32'h00000002;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR0_FIELD_VALUE = 3'h2;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_OFST = 8;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_OFST = 5;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_HIGH = 6;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_SIZE = 2;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_BITMASK = 32'h00000060;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_PMA_DATA_SEL_ADDR1_FIELD_VALUE = 2'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_VALUE = "tx_stat_polinv_dis";
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_OFST = 7;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_OFST = 2;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_HIGH = 2;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_SIZE = 1;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_BITMASK = 32'h00000004;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_TX_PCS_PMA_INTERFACE_TX_STATIC_POLARITY_INVERSION_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_TX_PCS_PMA_INTERFACE_RECONFIG_SETTINGS_VALUE = "{}";

localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_VALUE = "double_write_dis";
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_OFST = 197;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_OFST = 1;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_HIGH = 1;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_SIZE = 1;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_FIFO_TX_PCS_DOUBLE_WRITE_MODE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_FIFO_TX_PCS_PROT_MODE_VALUE = "non_teng_mode";
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_OFST = 197;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_OFST = 0;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_HIGH = 0;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_SIZE = 1;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_FIFO_TX_PCS_PROT_MODE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_VALUE = "false";
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_OFST = 104;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_OFST = 1;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_HIGH = 1;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_BITMASK = 32'h00000002;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_RX_DETECTION_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_VALUE = 3'd0;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_OFST = 109;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_OFST = 2;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_HIGH = 4;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_SIZE = 3;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_BITMASK = 32'h0000001C;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ADDR_FIELD_VALUE = 3'h0;

localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_VALUE = "false";
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_OFST = 105;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_OFST = 7;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_HIGH = 7;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_RX_PRESET_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_VALUE = 18'd0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_OFST = 107;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_OFST = 0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_HIGH = 7;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_SIZE = 8;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR0_FIELD_VALUE = 8'h0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_OFST = 108;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_OFST = 0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_HIGH = 7;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_SIZE = 8;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_BITMASK = 32'h000000FF;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR1_FIELD_VALUE = 8'h0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_OFST = 109;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_OFST = 0;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_HIGH = 1;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_SIZE = 2;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_BITMASK = 32'h00000003;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ADDR2_FIELD_VALUE = 2'h0;

localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_VALUE = "false";
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_OFST = 105;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_OFST = 6;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_HIGH = 6;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_BYPASS_TX_COEFFICENT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_VALUE = 3'd0;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_OFST = 106;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_OFST = 0;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_HIGH = 2;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_SIZE = 3;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_BITMASK = 32'h00000007;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_ELECIDLE_DELAY_G3_ADDR_FIELD_VALUE = 3'h0;

localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_VALUE = "dis_ind_error_reporting";
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_OFST = 104;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_OFST = 7;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_HIGH = 7;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_BITMASK = 32'h00000080;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_IND_ERROR_REPORTING_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_MODE_VALUE = "disable_pcs";

localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_VALUE = 3'd0;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_OFST = 104;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_OFST = 3;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_HIGH = 5;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_SIZE = 3;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_BITMASK = 32'h00000038;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G12_ADDR_FIELD_VALUE = 3'h0;

localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_VALUE = 3'd0;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_OFST = 106;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_OFST = 3;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_HIGH = 5;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_SIZE = 3;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_BITMASK = 32'h00000038;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_PHY_STATUS_DELAY_G3_ADDR_FIELD_VALUE = 3'h0;

localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_VALUE = "dis_phystatus_rst_toggle";
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_OFST = 104;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_OFST = 6;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_HIGH = 6;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G12_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_VALUE = "dis_phystatus_rst_toggle_g3";
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_OFST = 106;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_OFST = 6;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_HIGH = 6;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_BITMASK = 32'h00000040;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_PHYSTATUS_RST_TOGGLE_G3_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_VALUE = "dis_rm_fifo_pad_ins";
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_OFST = 104;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_OFST = 0;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_HIGH = 0;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_SIZE = 1;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_BITMASK = 32'h00000001;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_VALMASK = 32'h00000000;
localparam HSSI_PIPE_GEN3_RATE_MATCH_PAD_INSERTION_ADDR_FIELD_VALUE = 1'h0;

localparam HSSI_PIPE_GEN3_SUP_MODE_VALUE = "user_mode";

localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_VALUE = "disable_test_out";
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_OFST = 105;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_OFST = 2;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_HIGH = 5;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_SIZE = 4;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_BITMASK = 32'h0000003C;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_VALMASK = 32'h0000003C;
localparam HSSI_PIPE_GEN3_TEST_OUT_SEL_ADDR_FIELD_VALUE = 4'hF;

localparam PMA_CGB_BITSLIP_ENABLE_VALUE = "disable_bitslip";
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_OFST = 274;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_OFST = 2;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_HIGH = 2;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_SIZE = 1;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_BITMASK = 32'h00000004;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_CGB_BITSLIP_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam PMA_CGB_DATARATE_VALUE = "5400000000 bps";

localparam PMA_CGB_PCIE_GEN3_BITWIDTH_VALUE = "pciegen3_wide";
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_OFST = 281;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_OFST = 1;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_HIGH = 1;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_SIZE = 1;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_BITMASK = 32'h00000002;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_CGB_PCIE_GEN3_BITWIDTH_ADDR_FIELD_VALUE = 1'h0;

localparam PMA_CGB_PROT_MODE_VALUE = "basic_tx";

localparam PMA_CGB_SER_MODE_VALUE = "twenty_bit";
localparam PMA_CGB_SER_MODE_ADDR_OFST = 272;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_OFST = 0;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_HIGH = 2;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_SIZE = 3;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_BITMASK = 32'h00000007;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_VALMASK = 32'h00000005;
localparam PMA_CGB_SER_MODE_ADDR_FIELD_VALUE = 3'h5;

localparam PMA_CGB_SUP_MODE_VALUE = "user_mode";

localparam PMA_CGB_X1_DIV_M_SEL_VALUE = "divbypass";
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_OFST = 281;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_OFST = 2;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_HIGH = 3;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_SIZE = 2;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_CGB_X1_DIV_M_SEL_ADDR_FIELD_VALUE = 2'h0;

localparam PMA_CGB_INPUT_SELECT_X1_VALUE = "unused";

localparam PMA_CGB_INPUT_SELECT_GEN3_VALUE = "unused";

localparam PMA_CGB_INPUT_SELECT_XN_VALUE = "sel_x6_dn";

localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_VALUE = "divtx_user_off";
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_OFST = 272;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_OFST = 3;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_HIGH = 5;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_SIZE = 3;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_BITMASK = 32'h00000038;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_TX_SER_SER_CLK_DIVTX_USER_SEL_ADDR_FIELD_VALUE = 3'h0;

localparam PMA_TX_SER_SUP_MODE_VALUE = "user_mode";

localparam PMA_TX_SER_PROT_MODE_VALUE = "basic_tx";

localparam PMA_TX_BUF_DATARATE_VALUE = "5400000000 bps";

localparam PMA_TX_BUF_PROT_MODE_VALUE = "basic_tx";

localparam PMA_TX_BUF_RX_DET_VALUE = "mode_0";
localparam PMA_TX_BUF_RX_DET_ADDR_OFST = 269;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_OFST = 3;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_HIGH = 6;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_SIZE = 4;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_BITMASK = 32'h00000078;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_TX_BUF_RX_DET_ADDR_FIELD_VALUE = 4'h0;

localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_VALUE = "rx_det_pcie_out";
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_OFST = 269;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_OFST = 1;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_HIGH = 1;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_SIZE = 1;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_BITMASK = 32'h00000002;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_TX_BUF_RX_DET_OUTPUT_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam PMA_TX_BUF_RX_DET_PDB_VALUE = "rx_det_off";
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_OFST = 269;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_OFST = 2;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_HIGH = 2;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_SIZE = 1;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_BITMASK = 32'h00000004;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_TX_BUF_RX_DET_PDB_ADDR_FIELD_VALUE = 1'h0;

localparam PMA_TX_BUF_SUP_MODE_VALUE = "user_mode";

localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_VALUE = "ram_ctl";
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_OFST = 261;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_OFST = 7;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_HIGH = 7;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_SIZE = 1;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_BITMASK = 32'h00000080;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam PMA_TX_BUF_USER_FIR_COEFF_CTRL_SEL_ADDR_FIELD_VALUE = 1'h0;

localparam PMA_TX_BUF_XTX_PATH_PROT_MODE_VALUE = "basic_tx";

localparam PMA_TX_BUF_XTX_PATH_DATARATE_VALUE = "5400000000 bps";

localparam PMA_TX_BUF_XTX_PATH_DATAWIDTH_VALUE = 8'd20;

localparam PMA_TX_BUF_XTX_PATH_CLOCK_DIVIDER_RATIO_VALUE = 4'd1;

localparam PMA_TX_BUF_XTX_PATH_PMA_TX_DIVCLK_HZ_VALUE = "270000000";

localparam PMA_TX_BUF_XTX_PATH_TX_PLL_CLK_HZ_VALUE = "500000000";

localparam PMA_TX_BUF_XTX_PATH_SUP_MODE_VALUE = "user_mode";

endpackage