	component subsys_dp_aux_fifo is
		port (
			wrclock                         : in  std_logic                     := 'X';             -- clk
			avalonst_sink_valid             : in  std_logic                     := 'X';             -- valid
			avalonst_sink_data              : in  std_logic_vector(31 downto 0) := (others => 'X'); -- data
			avalonst_sink_channel           : in  std_logic                     := 'X';             -- channel
			avalonst_sink_error             : in  std_logic                     := 'X';             -- error
			avalonst_sink_startofpacket     : in  std_logic                     := 'X';             -- startofpacket
			avalonst_sink_endofpacket       : in  std_logic                     := 'X';             -- endofpacket
			avalonst_sink_ready             : out std_logic;                                        -- ready
			wrclk_control_slave_address     : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			wrclk_control_slave_read        : in  std_logic                     := 'X';             -- read
			wrclk_control_slave_writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			wrclk_control_slave_write       : in  std_logic                     := 'X';             -- write
			wrclk_control_slave_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			wrclk_control_slave_irq         : out std_logic;                                        -- irq
			avalonmm_read_slave_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			avalonmm_read_slave_read        : in  std_logic                     := 'X';             -- read
			avalonmm_read_slave_address     : in  std_logic                     := 'X';             -- address
			avalonmm_read_slave_waitrequest : out std_logic;                                        -- waitrequest
			reset_n                         : in  std_logic                     := 'X'              -- reset_n
		);
	end component subsys_dp_aux_fifo;

	u0 : component subsys_dp_aux_fifo
		port map (
			wrclock                         => CONNECTED_TO_wrclock,                         --   clk_in.clk
			avalonst_sink_valid             => CONNECTED_TO_avalonst_sink_valid,             --       in.valid
			avalonst_sink_data              => CONNECTED_TO_avalonst_sink_data,              --         .data
			avalonst_sink_channel           => CONNECTED_TO_avalonst_sink_channel,           --         .channel
			avalonst_sink_error             => CONNECTED_TO_avalonst_sink_error,             --         .error
			avalonst_sink_startofpacket     => CONNECTED_TO_avalonst_sink_startofpacket,     --         .startofpacket
			avalonst_sink_endofpacket       => CONNECTED_TO_avalonst_sink_endofpacket,       --         .endofpacket
			avalonst_sink_ready             => CONNECTED_TO_avalonst_sink_ready,             --         .ready
			wrclk_control_slave_address     => CONNECTED_TO_wrclk_control_slave_address,     --   in_csr.address
			wrclk_control_slave_read        => CONNECTED_TO_wrclk_control_slave_read,        --         .read
			wrclk_control_slave_writedata   => CONNECTED_TO_wrclk_control_slave_writedata,   --         .writedata
			wrclk_control_slave_write       => CONNECTED_TO_wrclk_control_slave_write,       --         .write
			wrclk_control_slave_readdata    => CONNECTED_TO_wrclk_control_slave_readdata,    --         .readdata
			wrclk_control_slave_irq         => CONNECTED_TO_wrclk_control_slave_irq,         --   in_irq.irq
			avalonmm_read_slave_readdata    => CONNECTED_TO_avalonmm_read_slave_readdata,    --      out.readdata
			avalonmm_read_slave_read        => CONNECTED_TO_avalonmm_read_slave_read,        --         .read
			avalonmm_read_slave_address     => CONNECTED_TO_avalonmm_read_slave_address,     --         .address
			avalonmm_read_slave_waitrequest => CONNECTED_TO_avalonmm_read_slave_waitrequest, --         .waitrequest
			reset_n                         => CONNECTED_TO_reset_n                          -- reset_in.reset_n
		);

