	component subsys_dp_bitec_dp_0 is
		port (
			aux_clk                 : in  std_logic                      := 'X';             -- clk
			aux_reset               : in  std_logic                      := 'X';             -- reset
			clk                     : in  std_logic                      := 'X';             -- clk
			clk_cal                 : in  std_logic                      := 'X';             -- clk
			reset                   : in  std_logic                      := 'X';             -- reset
			tx_analog_reconfig_req  : out std_logic;                                         -- analog_reconfig_req
			tx_analog_reconfig_ack  : in  std_logic                      := 'X';             -- analog_reconfig_ack
			tx_analog_reconfig_busy : in  std_logic                      := 'X';             -- analog_reconfig_busy
			tx_vod                  : out std_logic_vector(7 downto 0);                      -- vod
			tx_emp                  : out std_logic_vector(7 downto 0);                      -- emp
			tx_aux_in               : in  std_logic                      := 'X';             -- aux_in
			tx_aux_out              : out std_logic;                                         -- aux_out
			tx_aux_oe               : out std_logic;                                         -- aux_oe
			tx_hpd                  : in  std_logic                      := 'X';             -- hpd
			tx_aux_debug_data       : out std_logic_vector(31 downto 0);                     -- data
			tx_aux_debug_valid      : out std_logic;                                         -- valid
			tx_aux_debug_sop        : out std_logic;                                         -- startofpacket
			tx_aux_debug_eop        : out std_logic;                                         -- endofpacket
			tx_aux_debug_err        : out std_logic;                                         -- error
			tx_aux_debug_cha        : out std_logic;                                         -- channel
			tx_mgmt_address         : in  std_logic_vector(8 downto 0)   := (others => 'X'); -- address
			tx_mgmt_chipselect      : in  std_logic                      := 'X';             -- chipselect
			tx_mgmt_read            : in  std_logic                      := 'X';             -- read
			tx_mgmt_write           : in  std_logic                      := 'X';             -- write
			tx_mgmt_writedata       : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- writedata
			tx_mgmt_readdata        : out std_logic_vector(31 downto 0);                     -- readdata
			tx_mgmt_waitrequest     : out std_logic;                                         -- waitrequest
			tx_mgmt_irq             : out std_logic;                                         -- irq
			tx_link_rate            : out std_logic_vector(1 downto 0);                      -- link_rate
			tx_link_rate_8bits      : out std_logic_vector(7 downto 0);                      -- link_rate_8bits
			tx_reconfig_req         : out std_logic;                                         -- reconfig_req
			tx_reconfig_ack         : in  std_logic                      := 'X';             -- reconfig_ack
			tx_reconfig_busy        : in  std_logic                      := 'X';             -- reconfig_busy
			tx_vid_clk              : in  std_logic                      := 'X';             -- clk
			tx_vid_data             : in  std_logic_vector(23 downto 0)  := (others => 'X'); -- data
			tx_vid_v_sync           : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- v_sync
			tx_vid_h_sync           : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- h_sync
			tx_vid_de               : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- de
			tx_parallel_data        : out std_logic_vector(159 downto 0);                    -- parallel_data
			tx_pll_powerdown        : out std_logic;                                         -- pll_powerdown
			tx_analogreset          : out std_logic_vector(3 downto 0);                      -- analogreset
			tx_digitalreset         : out std_logic_vector(3 downto 0);                      -- digitalreset
			tx_cal_busy             : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- cal_busy
			tx_std_clkout           : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- std_clkout
			tx_pll_locked           : in  std_logic                      := 'X';             -- pll_locked
			xcvr_mgmt_clk           : in  std_logic                      := 'X'              -- clk
		);
	end component subsys_dp_bitec_dp_0;

	u0 : component subsys_dp_bitec_dp_0
		port map (
			aux_clk                 => CONNECTED_TO_aux_clk,                 --            aux_clk.clk
			aux_reset               => CONNECTED_TO_aux_reset,               --          aux_reset.reset
			clk                     => CONNECTED_TO_clk,                     --                clk.clk
			clk_cal                 => CONNECTED_TO_clk_cal,                 --            clk_cal.clk
			reset                   => CONNECTED_TO_reset,                   --              reset.reset
			tx_analog_reconfig_req  => CONNECTED_TO_tx_analog_reconfig_req,  -- tx_analog_reconfig.analog_reconfig_req
			tx_analog_reconfig_ack  => CONNECTED_TO_tx_analog_reconfig_ack,  --                   .analog_reconfig_ack
			tx_analog_reconfig_busy => CONNECTED_TO_tx_analog_reconfig_busy, --                   .analog_reconfig_busy
			tx_vod                  => CONNECTED_TO_tx_vod,                  --                   .vod
			tx_emp                  => CONNECTED_TO_tx_emp,                  --                   .emp
			tx_aux_in               => CONNECTED_TO_tx_aux_in,               --             tx_aux.aux_in
			tx_aux_out              => CONNECTED_TO_tx_aux_out,              --                   .aux_out
			tx_aux_oe               => CONNECTED_TO_tx_aux_oe,               --                   .aux_oe
			tx_hpd                  => CONNECTED_TO_tx_hpd,                  --                   .hpd
			tx_aux_debug_data       => CONNECTED_TO_tx_aux_debug_data,       --       tx_aux_debug.data
			tx_aux_debug_valid      => CONNECTED_TO_tx_aux_debug_valid,      --                   .valid
			tx_aux_debug_sop        => CONNECTED_TO_tx_aux_debug_sop,        --                   .startofpacket
			tx_aux_debug_eop        => CONNECTED_TO_tx_aux_debug_eop,        --                   .endofpacket
			tx_aux_debug_err        => CONNECTED_TO_tx_aux_debug_err,        --                   .error
			tx_aux_debug_cha        => CONNECTED_TO_tx_aux_debug_cha,        --                   .channel
			tx_mgmt_address         => CONNECTED_TO_tx_mgmt_address,         --            tx_mgmt.address
			tx_mgmt_chipselect      => CONNECTED_TO_tx_mgmt_chipselect,      --                   .chipselect
			tx_mgmt_read            => CONNECTED_TO_tx_mgmt_read,            --                   .read
			tx_mgmt_write           => CONNECTED_TO_tx_mgmt_write,           --                   .write
			tx_mgmt_writedata       => CONNECTED_TO_tx_mgmt_writedata,       --                   .writedata
			tx_mgmt_readdata        => CONNECTED_TO_tx_mgmt_readdata,        --                   .readdata
			tx_mgmt_waitrequest     => CONNECTED_TO_tx_mgmt_waitrequest,     --                   .waitrequest
			tx_mgmt_irq             => CONNECTED_TO_tx_mgmt_irq,             --  tx_mgmt_interrupt.irq
			tx_link_rate            => CONNECTED_TO_tx_link_rate,            --        tx_reconfig.link_rate
			tx_link_rate_8bits      => CONNECTED_TO_tx_link_rate_8bits,      --                   .link_rate_8bits
			tx_reconfig_req         => CONNECTED_TO_tx_reconfig_req,         --                   .reconfig_req
			tx_reconfig_ack         => CONNECTED_TO_tx_reconfig_ack,         --                   .reconfig_ack
			tx_reconfig_busy        => CONNECTED_TO_tx_reconfig_busy,        --                   .reconfig_busy
			tx_vid_clk              => CONNECTED_TO_tx_vid_clk,              --         tx_vid_clk.clk
			tx_vid_data             => CONNECTED_TO_tx_vid_data,             --        tx_video_in.data
			tx_vid_v_sync           => CONNECTED_TO_tx_vid_v_sync,           --                   .v_sync
			tx_vid_h_sync           => CONNECTED_TO_tx_vid_h_sync,           --                   .h_sync
			tx_vid_de               => CONNECTED_TO_tx_vid_de,               --                   .de
			tx_parallel_data        => CONNECTED_TO_tx_parallel_data,        --  tx_xcvr_interface.parallel_data
			tx_pll_powerdown        => CONNECTED_TO_tx_pll_powerdown,        --                   .pll_powerdown
			tx_analogreset          => CONNECTED_TO_tx_analogreset,          --                   .analogreset
			tx_digitalreset         => CONNECTED_TO_tx_digitalreset,         --                   .digitalreset
			tx_cal_busy             => CONNECTED_TO_tx_cal_busy,             --                   .cal_busy
			tx_std_clkout           => CONNECTED_TO_tx_std_clkout,           --                   .std_clkout
			tx_pll_locked           => CONNECTED_TO_tx_pll_locked,           --                   .pll_locked
			xcvr_mgmt_clk           => CONNECTED_TO_xcvr_mgmt_clk            --      xcvr_mgmt_clk.clk
		);

