	component subsys_dp_cvo is
		port (
			clocked_video_vid_clk       : in  std_logic                     := 'X';             -- vid_clk
			clocked_video_vid_data      : out std_logic_vector(31 downto 0);                    -- vid_data
			clocked_video_underflow     : out std_logic;                                        -- underflow
			clocked_video_vid_datavalid : out std_logic;                                        -- vid_datavalid
			clocked_video_vid_v_sync    : out std_logic;                                        -- vid_v_sync
			clocked_video_vid_h_sync    : out std_logic;                                        -- vid_h_sync
			clocked_video_vid_f         : out std_logic;                                        -- vid_f
			clocked_video_vid_h         : out std_logic;                                        -- vid_h
			clocked_video_vid_v         : out std_logic;                                        -- vid_v
			din_data                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- data
			din_valid                   : in  std_logic                     := 'X';             -- valid
			din_startofpacket           : in  std_logic                     := 'X';             -- startofpacket
			din_endofpacket             : in  std_logic                     := 'X';             -- endofpacket
			din_ready                   : out std_logic;                                        -- ready
			main_clock_clk              : in  std_logic                     := 'X';             -- clk
			main_reset_reset            : in  std_logic                     := 'X';             -- reset
			status_update_irq_irq       : out std_logic                                         -- irq
		);
	end component subsys_dp_cvo;

	u0 : component subsys_dp_cvo
		port map (
			clocked_video_vid_clk       => CONNECTED_TO_clocked_video_vid_clk,       --     clocked_video.vid_clk
			clocked_video_vid_data      => CONNECTED_TO_clocked_video_vid_data,      --                  .vid_data
			clocked_video_underflow     => CONNECTED_TO_clocked_video_underflow,     --                  .underflow
			clocked_video_vid_datavalid => CONNECTED_TO_clocked_video_vid_datavalid, --                  .vid_datavalid
			clocked_video_vid_v_sync    => CONNECTED_TO_clocked_video_vid_v_sync,    --                  .vid_v_sync
			clocked_video_vid_h_sync    => CONNECTED_TO_clocked_video_vid_h_sync,    --                  .vid_h_sync
			clocked_video_vid_f         => CONNECTED_TO_clocked_video_vid_f,         --                  .vid_f
			clocked_video_vid_h         => CONNECTED_TO_clocked_video_vid_h,         --                  .vid_h
			clocked_video_vid_v         => CONNECTED_TO_clocked_video_vid_v,         --                  .vid_v
			din_data                    => CONNECTED_TO_din_data,                    --               din.data
			din_valid                   => CONNECTED_TO_din_valid,                   --                  .valid
			din_startofpacket           => CONNECTED_TO_din_startofpacket,           --                  .startofpacket
			din_endofpacket             => CONNECTED_TO_din_endofpacket,             --                  .endofpacket
			din_ready                   => CONNECTED_TO_din_ready,                   --                  .ready
			main_clock_clk              => CONNECTED_TO_main_clock_clk,              --        main_clock.clk
			main_reset_reset            => CONNECTED_TO_main_reset_reset,            --        main_reset.reset
			status_update_irq_irq       => CONNECTED_TO_status_update_irq_irq        -- status_update_irq.irq
		);

