package altera_xcvr_fpll_a10_reconfig_parameters;

localparam ram_depth = 42;
function [25:0] get_ram_data;
  input integer index;
  automatic reg [0:41][25:0] ram_data = {
    26'h1018C0C, // [25:16]-DPRIO address=0x101; [15:8]-bit mask=0x8C; [7:7]-cmu_fpll_pll_rstn_override=false(1'h0); [3:3]-cmu_fpll_pll_cmu_rstn_value=true(1'h1); [2:2]-cmu_fpll_pll_lpf_rstn_value=lpf_normal(1'h1);
    26'h102FF10, // [25:16]-DPRIO address=0x102; [15:8]-bit mask=0xFF; [7:7]-cmu_fpll_pll_cp_testmode=cp_normal(1'h0); [6:6]-cmu_fpll_pll_ctrl_override_setting=true(1'h0); [5:5]-cmu_fpll_pll_nreset_invert=false(1'h0); [4:4]-cmu_fpll_pll_enable=true(1'h1); [3:2]-cmu_fpll_pll_self_reset=false(2'h0); [1:1]-cmu_fpll_pll_test_enable=false(1'h0); [0:0]-cmu_fpll_pll_vccr_pd_en=true(1'h0);
    26'h103E0E0, // [25:16]-DPRIO address=0x103; [15:8]-bit mask=0xE0; [7:7]-cmu_fpll_pll_c_counter_3_min_tco_enable=false(1'h1); [6:5]-cmu_fpll_pll_c_counter_3_in_src=m_cnt_in_src_test_clk(2'h3);
    26'h104FF01, // [25:16]-DPRIO address=0x104; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_3_prst=1(8'h1);
    26'h105E0E0, // [25:16]-DPRIO address=0x105; [15:8]-bit mask=0xE0; [7:7]-cmu_fpll_pll_c_counter_2_min_tco_enable=false(1'h1); [6:5]-cmu_fpll_pll_c_counter_2_in_src=m_cnt_in_src_test_clk(2'h3);
    26'h106FF01, // [25:16]-DPRIO address=0x106; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_2_prst=1(8'h1);
    26'h107E0E0, // [25:16]-DPRIO address=0x107; [15:8]-bit mask=0xE0; [7:7]-cmu_fpll_pll_c_counter_1_min_tco_enable=false(1'h1); [6:5]-cmu_fpll_pll_c_counter_1_in_src=m_cnt_in_src_test_clk(2'h3);
    26'h108FF01, // [25:16]-DPRIO address=0x108; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_1_prst=1(8'h1);
    26'h109E0E0, // [25:16]-DPRIO address=0x109; [15:8]-bit mask=0xE0; [7:7]-cmu_fpll_pll_c_counter_0_min_tco_enable=false(1'h1); [6:5]-cmu_fpll_pll_c_counter_0_in_src=m_cnt_in_src_test_clk(2'h3);
    26'h10A3F21, // [25:16]-DPRIO address=0x10A; [15:8]-bit mask=0x3F; [5:5]-cmu_fpll_pll_lpf_rstn_value=lpf_normal(1'h1); [4:0]-cmu_fpll_pll_vco_freq_band_0_fix=1(5'h1);
    26'h10BF800, // [25:16]-DPRIO address=0x10B; [15:8]-bit mask=0xF8; [7:6]-cmu_fpll_pll_vco_freq_band_0_dyn_high_bits=0(2'h0); [5:3]-cmu_fpll_pll_vco_freq_band_0_dyn_low_bits=0(3'h0);
    26'h10CFF01, // [25:16]-DPRIO address=0x10C; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_0_prst=1(8'h1);
    26'h10DFF01, // [25:16]-DPRIO address=0x10D; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_3=1(8'h1);
    26'h10EFF01, // [25:16]-DPRIO address=0x10E; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_2=1(8'h1);
    26'h10FFF01, // [25:16]-DPRIO address=0x10F; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_1=1(8'h1);
    26'h110FF01, // [25:16]-DPRIO address=0x110; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_c_counter_0=1(8'h1);
    26'h111FF00, // [25:16]-DPRIO address=0x111; [15:8]-bit mask=0xFF; [7:7]-cmu_fpll_pll_c3_pllcout_enable=false(1'h0); [6:6]-cmu_fpll_pll_c2_pllcout_enable=false(1'h0); [5:5]-cmu_fpll_pll_c1_pllcout_enable=false(1'h0); [4:4]-cmu_fpll_pll_c0_pllcout_enable=false(1'h0); [3:3]-cmu_fpll_pll_c_counter_0=1(1'h0); [2:2]-cmu_fpll_pll_c_counter_1=1(1'h0); [1:1]-cmu_fpll_pll_c_counter_2=1(1'h0); [0:0]-cmu_fpll_pll_c_counter_3=1(1'h0);
    26'h113F818, // [25:16]-DPRIO address=0x113; [15:8]-bit mask=0xF8; [7:7]-cmu_fpll_fpll_hclk_out_enable=fpll_hclk_out_disable(1'h0); [6:6]-cmu_fpll_fpll_iqtxrxclk_out_enable=fpll_iqtxrxclk_out_disable(1'h0); [5:5]-cmu_fpll_fpll_cas_out_enable=fpll_cas_out_disable(1'h0); [4:4]-cmu_fpll_pll_m_counter_min_tco_enable=false(1'h1); [3:3]-cmu_fpll_pll_l_counter_enable=true(1'h1);
    26'h115FF00, // [25:16]-DPRIO address=0x115; [15:8]-bit mask=0xFF; [7:6]-cmu_fpll_pll_c_counter_3_ph_mux_prst=0(2'h0); [5:4]-cmu_fpll_pll_c_counter_2_ph_mux_prst=0(2'h0); [3:2]-cmu_fpll_pll_c_counter_1_ph_mux_prst=0(2'h0); [1:0]-cmu_fpll_pll_c_counter_0_ph_mux_prst=0(2'h0);
    26'h1221F00, // [25:16]-DPRIO address=0x122; [15:8]-bit mask=0x1F; [4:3]-cmu_fpll_pll_fbclk_mux_1=pll_fbclk_mux_1_glb(2'h0); [2:0]-cmu_fpll_pll_iqclk_mux_sel=power_down(3'h0);
    26'h1233F21, // [25:16]-DPRIO address=0x123; [15:8]-bit mask=0x3F; [5:5]-cmu_fpll_pll_lpf_rstn_value=lpf_normal(1'h1); [4:0]-cmu_fpll_pll_vco_freq_band_1_fix=1(5'h1);
    26'h124F800, // [25:16]-DPRIO address=0x124; [15:8]-bit mask=0xF8; [7:6]-cmu_fpll_pll_vco_freq_band_1_dyn_high_bits=0(2'h0); [5:3]-cmu_fpll_pll_vco_freq_band_1_dyn_low_bits=0(3'h0);
    26'h1260101, // [25:16]-DPRIO address=0x126; [15:8]-bit mask=0x01; [0:0]-cmu_fpll_pll_fbclk_mux_2=pll_fbclk_mux_2_m_cnt(1'h1);
    26'h128E000, // [25:16]-DPRIO address=0x128; [15:8]-bit mask=0xE0; [7:7]-cmu_fpll_pll_test_enable=false(1'h0); [6:5]-cmu_fpll_pll_m_counter_in_src=m_cnt_in_src_ph_mux_clk(2'h0);
    26'h12AFC04, // [25:16]-DPRIO address=0x12A; [15:8]-bit mask=0xFC; [7:6]-cmu_fpll_pll_dsm_out_sel=pll_dsm_disable(2'h0); [5:5]-cmu_fpll_pll_dsm_mode=dsm_mode_integer(1'h0); [4:4]-cmu_fpll_pll_dsm_ecn_bypass=false(1'h0); [3:3]-cmu_fpll_pll_dsm_ecn_test_en=false(1'h0); [2:2]-cmu_fpll_pll_dsm_fractional_value_ready=pll_k_ready(1'h1);
    26'h12BFF14, // [25:16]-DPRIO address=0x12B; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_m_counter=20(8'h14);
    26'h12CFF0A, // [25:16]-DPRIO address=0x12C; [15:8]-bit mask=0xFF; [7:3]-cmu_fpll_pll_n_counter=1(5'h1); [2:1]-cmu_fpll_pll_l_counter=2(2'h1); [0:0]-cmu_fpll_pll_m_counter=20(1'h0);
    26'h12DFF01, // [25:16]-DPRIO address=0x12D; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_dsm_fractional_division=1(8'h1);
    26'h12EFF00, // [25:16]-DPRIO address=0x12E; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_dsm_fractional_division=1(8'h0);
    26'h12FFF00, // [25:16]-DPRIO address=0x12F; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_dsm_fractional_division=1(8'h0);
    26'h130FF00, // [25:16]-DPRIO address=0x130; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_dsm_fractional_division=1(8'h0);
    26'h1337F4A, // [25:16]-DPRIO address=0x133; [15:8]-bit mask=0x7F; [6:6]-cmu_fpll_pll_cp_lf_order=lf_2nd_order(1'h1); [5:4]-cmu_fpll_pll_lf_ripplecap=lf_no_ripple(2'h0); [3:2]-cmu_fpll_pll_lf_resistance=lf_res_setting2(2'h2); [1:1]-cmu_fpll_pll_cp_compensation=true(1'h1); [0:0]-cmu_fpll_pll_cp_testmode=cp_normal(1'h0);
    26'h1347C40, // [25:16]-DPRIO address=0x134; [15:8]-bit mask=0x7C; [6:4]-cmu_fpll_pll_cp_current_setting=cp_current_setting32(3'h4); [3:2]-cmu_fpll_pll_cp_lf_3rd_pole_freq=lf_3rd_pole_setting0(2'h0);
    26'h135FF04, // [25:16]-DPRIO address=0x135; [15:8]-bit mask=0xFF; [7:3]-cmu_fpll_pll_atb=atb_selectdisable(5'h0); [2:0]-cmu_fpll_pll_cp_current_setting=cp_current_setting32(3'h4);
    26'h1363F21, // [25:16]-DPRIO address=0x136; [15:8]-bit mask=0x3F; [5:5]-cmu_fpll_pll_tclk_sel=pll_tclk_m_src(1'h1); [4:4]-cmu_fpll_pll_tclk_mux_en=false(1'h0); [3:3]-cmu_fpll_pll_vco_ph3_en=false(1'h0); [2:2]-cmu_fpll_pll_vco_ph2_en=false(1'h0); [1:1]-cmu_fpll_pll_vco_ph1_en=false(1'h0); [0:0]-cmu_fpll_pll_vco_ph0_en=true(1'h1);
    26'h137FF19, // [25:16]-DPRIO address=0x137; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_pll_lock_fltr_cfg=25(8'h19);
    26'h138FF20, // [25:16]-DPRIO address=0x138; [15:8]-bit mask=0xFF; [7:7]-cmu_fpll_pll_lock_fltr_test=pll_lock_fltr_nrm(1'h0); [6:4]-cmu_fpll_pll_unlock_fltr_cfg=2(3'h2); [3:0]-cmu_fpll_pll_lock_fltr_cfg=25(4'h0);
    26'h139E000, // [25:16]-DPRIO address=0x139; [15:8]-bit mask=0xE0; [7:5]-cmu_fpll_pll_dprio_status_select=dprio_normal_status(3'h0);
    26'h140FF00, // [25:16]-DPRIO address=0x140; [15:8]-bit mask=0xFF; [7:7]-cmu_fpll_pll_ctrl_plniotri_override=false(1'h0); [6:6]-cmu_fpll_pll_l_counter_bypass=false(1'h0); [5:3]-cmu_fpll_pll_ppm_clk1_src=ppm_clk1_vss(3'h0); [2:0]-cmu_fpll_pll_ppm_clk0_src=ppm_clk0_vss(3'h0);
    26'h1413F0F, // [25:16]-DPRIO address=0x141; [15:8]-bit mask=0x3F; [5:5]-cmu_fpll_xpm_cmu_fpll_core_xpm_cpvco_fpll_xpm_chgpmplf_fpll_cp_current_boost=normal_setting(1'h0); [4:4]-cmu_fpll_xpm_cmu_fpll_core_fpll_refclk_source=normal_refclk(1'h0); [3:0]-cmu_fpll_pll_lf_cbig=lf_cbig_setting4(4'hF);
    26'h1427F00, // [25:16]-DPRIO address=0x142; [15:8]-bit mask=0x7F; [6:6]-cmu_fpll_xpm_cmu_fpll_core_cal_vco_count_length=sel_8b_count(1'h0); [5:5]-cmu_fpll_pll_vco_freq_band_1_fix_high=pll_vco_freq_band_1_fix_high_0(1'h0); [4:4]-cmu_fpll_pll_vco_freq_band_0_fix_high=pll_vco_freq_band_0_fix_high_0(1'h0); [3:2]-cmu_fpll_xpm_cmu_fpll_core_pfd_delay_compensation=normal_delay(2'h0); [1:0]-cmu_fpll_xpm_cmu_fpll_core_pfd_pulse_width=pulse_width_setting0(2'h0);
    26'h143FF00  // [25:16]-DPRIO address=0x143; [15:8]-bit mask=0xFF; [7:0]-cmu_fpll_set_fpll_input_freq_range=0(8'h0);
};

  begin
  get_ram_data = ram_data[index];
  end
endfunction

localparam CMU_FPLL_IS_OTN_VALUE = "false";

localparam CMU_FPLL_IS_SDI_VALUE = "false";

localparam CMU_FPLL_FEEDBACK_VALUE = "normal";

localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_VALUE = "fpll_cas_out_disable";
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_OFST = 275;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_FPLL_CAS_OUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_VALUE = "fpll_hclk_out_disable";
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_OFST = 275;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_FPLL_HCLK_OUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_VALUE = "fpll_iqtxrxclk_out_disable";
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_OFST = 275;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_FPLL_IQTXRXCLK_OUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_L_COUNTER_VALUE = 6'd2;

localparam CMU_FPLL_M_COUNTER_VALUE = 8'd20;

localparam CMU_FPLL_N_COUNTER_VALUE = 6'd1;

localparam CMU_FPLL_OUT_FREQ_HZ_VALUE = "0 hz";

localparam CMU_FPLL_OUT_FREQ_VALUE = "000010100000111011101011101100000000";

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_VALUE = "pll_freq_band0";

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_VALUE = "pll_freq_band0_1";

localparam CMU_FPLL_PRIMARY_USE_VALUE = "tx";

localparam CMU_FPLL_PROT_MODE_VALUE = "basic_tx";

localparam CMU_FPLL_REFERENCE_CLOCK_FREQUENCY_SCRATCH_VALUE = "0 hz";

localparam CMU_FPLL_SIDE_VALUE = "side_unknown";

localparam CMU_FPLL_TOP_OR_BOTTOM_VALUE = "tb_unknown";

localparam CMU_FPLL_VCO_FREQ_HZ_VALUE = "10800000000";

localparam CMU_FPLL_VCO_FREQ_VALUE = "001010000011101110101110110000000000";

localparam CMU_FPLL_PLL_BW_MODE_VALUE = "mid_bw";

localparam CMU_FPLL_DATARATE_VALUE = "5400000000 bps";

localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_VALUE = "true";
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_OFST = 257;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_BITMASK = 32'h00000008;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_VALMASK = 32'h00000008;
localparam CMU_FPLL_PLL_CMU_RSTN_VALUE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_VALUE = "lpf_normal";
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_OFST = 257;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_BITMASK = 32'h00000004;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_VALMASK = 32'h00000004;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR0_FIELD_VALUE = 1'h1;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_OFST = 266;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_VALMASK = 32'h00000020;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR1_FIELD_VALUE = 1'h1;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_OFST = 291;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_VALMASK = 32'h00000020;
localparam CMU_FPLL_PLL_LPF_RSTN_VALUE_ADDR2_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_PPM_CLK0_SRC_VALUE = "ppm_clk0_vss";
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_OFST = 320;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_BITMASK = 32'h00000007;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_PPM_CLK0_SRC_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_PLL_PPM_CLK1_SRC_VALUE = "ppm_clk1_vss";
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_OFST = 320;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_BITMASK = 32'h00000038;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_PPM_CLK1_SRC_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_PLL_RSTN_OVERRIDE_VALUE = "false";
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_OFST = 257;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_RSTN_OVERRIDE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_OP_MODE_VALUE = "false";

localparam CMU_FPLL_PLL_OPTIMAL_VALUE = "true";

localparam CMU_FPLL_IS_PA_CORE_VALUE = "false";

localparam CMU_FPLL_PLL_POWERDOWN_MODE_VALUE = "false";

localparam CMU_FPLL_PLL_SUP_MODE_VALUE = "user_mode";

localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_OFST = 273;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C0_PLLCOUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_0_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_OFST = 272;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR0_FIELD_VALUE = 8'h1;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_OFST = 273;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_BITMASK = 32'h00000008;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_0_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_OFST = 265;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_VALMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_0_MIN_TCO_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_VALUE = "m_cnt_in_src_test_clk";
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_OFST = 265;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_BITMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_VALMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_0_IN_SRC_ADDR_FIELD_VALUE = 2'h3;

localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_VALUE = 0;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_OFST = 277;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_HIGH = 1;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_BITMASK = 32'h00000003;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_0_PH_MUX_PRST_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_OFST = 268;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_0_PRST_ADDR_FIELD_VALUE = 8'h1;

localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_OFST = 273;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C1_PLLCOUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_1_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_OFST = 271;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR0_FIELD_VALUE = 8'h1;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_OFST = 273;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_BITMASK = 32'h00000004;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_1_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_OFST = 263;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_VALMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_1_MIN_TCO_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_VALUE = "m_cnt_in_src_test_clk";
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_OFST = 263;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_BITMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_VALMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_1_IN_SRC_ADDR_FIELD_VALUE = 2'h3;

localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_VALUE = 0;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_OFST = 277;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_1_PH_MUX_PRST_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_OFST = 264;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_1_PRST_ADDR_FIELD_VALUE = 8'h1;

localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_OFST = 273;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C2_PLLCOUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_2_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_OFST = 270;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR0_FIELD_VALUE = 8'h1;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_OFST = 273;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_OFST = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_HIGH = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_BITMASK = 32'h00000002;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_2_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_OFST = 261;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_VALMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_2_MIN_TCO_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_VALUE = "m_cnt_in_src_test_clk";
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_OFST = 261;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_BITMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_VALMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_2_IN_SRC_ADDR_FIELD_VALUE = 2'h3;

localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_VALUE = 0;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_OFST = 277;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_BITMASK = 32'h00000030;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_2_PH_MUX_PRST_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_OFST = 262;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_2_PRST_ADDR_FIELD_VALUE = 8'h1;

localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_OFST = 273;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C3_PLLCOUT_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_3_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_OFST = 269;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR0_FIELD_VALUE = 8'h1;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_OFST = 273;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_3_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_OFST = 259;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_VALMASK = 32'h00000080;
localparam CMU_FPLL_PLL_C_COUNTER_3_MIN_TCO_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_VALUE = "m_cnt_in_src_test_clk";
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_OFST = 259;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_BITMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_VALMASK = 32'h00000060;
localparam CMU_FPLL_PLL_C_COUNTER_3_IN_SRC_ADDR_FIELD_VALUE = 2'h3;

localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_VALUE = 0;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_OFST = 277;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_BITMASK = 32'h000000C0;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_C_COUNTER_3_PH_MUX_PRST_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_VALUE = 1;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_OFST = 260;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_C_COUNTER_3_PRST_ADDR_FIELD_VALUE = 8'h1;

localparam CMU_FPLL_PLL_ATB_VALUE = "atb_selectdisable";
localparam CMU_FPLL_PLL_ATB_ADDR_OFST = 309;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_SIZE = 5;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_BITMASK = 32'h000000F8;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_ATB_ADDR_FIELD_VALUE = 5'h0;

localparam CMU_FPLL_PLL_FBCLK_MUX_1_VALUE = "pll_fbclk_mux_1_glb";
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_OFST = 290;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_BITMASK = 32'h00000018;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_FBCLK_MUX_1_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_FBCLK_MUX_2_VALUE = "pll_fbclk_mux_2_m_cnt";
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_OFST = 294;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_FBCLK_MUX_2_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_VALUE = "power_down";
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_OFST = 290;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_BITMASK = 32'h00000007;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_IQCLK_MUX_SEL_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_PLL_CP_COMPENSATION_VALUE = "true";
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_OFST = 307;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_OFST = 1;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_HIGH = 1;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_BITMASK = 32'h00000002;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_VALMASK = 32'h00000002;
localparam CMU_FPLL_PLL_CP_COMPENSATION_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_VALUE = "cp_current_setting32";
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_OFST = 308;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_BITMASK = 32'h00000070;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_VALMASK = 32'h00000040;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_VALUE = 3'h4;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_OFST = 309;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_BITMASK = 32'h00000007;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_VALMASK = 32'h00000004;
localparam CMU_FPLL_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_VALUE = 3'h4;

localparam CMU_FPLL_PLL_CP_TESTMODE_VALUE = "cp_normal";
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_OFST = 258;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR0_FIELD_VALUE = 1'h0;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_OFST = 307;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_CP_TESTMODE_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_VALUE = "lf_3rd_pole_setting0";
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_OFST = 308;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_LF_CBIG_VALUE = "lf_cbig_setting4";
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_OFST = 321;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_SIZE = 4;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_BITMASK = 32'h0000000F;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_VALMASK = 32'h0000000F;
localparam CMU_FPLL_PLL_LF_CBIG_ADDR_FIELD_VALUE = 4'hF;

localparam CMU_FPLL_PLL_CP_LF_ORDER_VALUE = "lf_2nd_order";
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_OFST = 307;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_VALMASK = 32'h00000040;
localparam CMU_FPLL_PLL_CP_LF_ORDER_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_LF_RESISTANCE_VALUE = "lf_res_setting2";
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_OFST = 307;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_VALMASK = 32'h00000008;
localparam CMU_FPLL_PLL_LF_RESISTANCE_ADDR_FIELD_VALUE = 2'h2;

localparam CMU_FPLL_PLL_LF_RIPPLECAP_VALUE = "lf_no_ripple";
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_OFST = 307;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_BITMASK = 32'h00000030;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_LF_RIPPLECAP_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_VCO_PH0_EN_VALUE = "true";
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_VCO_PH0_EN_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_VCO_PH1_EN_VALUE = "false";
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_OFST = 1;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_HIGH = 1;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_BITMASK = 32'h00000002;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_PH1_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_VCO_PH2_EN_VALUE = "false";
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_BITMASK = 32'h00000004;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_PH2_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_VCO_PH3_EN_VALUE = "false";
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_BITMASK = 32'h00000008;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_PH3_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_DSM_MODE_VALUE = "dsm_mode_integer";
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_OFST = 298;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_MODE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_DSM_OUT_SEL_VALUE = "pll_dsm_disable";
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_OFST = 298;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_BITMASK = 32'h000000C0;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_OUT_SEL_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_VALUE = "false";
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_OFST = 298;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_ECN_BYPASS_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_VALUE = "false";
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_OFST = 298;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_BITMASK = 32'h00000008;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_VALUE = 32'd1;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_OFST = 301;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_VALUE = 8'h1;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_OFST = 302;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_VALUE = 8'h0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_OFST = 303;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_VALUE = 8'h0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_OFST = 304;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_VALUE = 8'h0;

localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_VALUE = "pll_k_ready";
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_OFST = 298;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_BITMASK = 32'h00000004;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_VALMASK = 32'h00000004;
localparam CMU_FPLL_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_VALUE = "false";
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_OFST = 320;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_L_COUNTER_BYPASS_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_L_COUNTER_VALUE = 2;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_OFST = 300;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_OFST = 1;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_HIGH = 2;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_BITMASK = 32'h00000006;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_VALMASK = 32'h00000002;
localparam CMU_FPLL_PLL_L_COUNTER_ADDR_FIELD_VALUE = 2'h1;

localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_VALUE = "true";
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_OFST = 275;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_BITMASK = 32'h00000008;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_VALMASK = 32'h00000008;
localparam CMU_FPLL_PLL_L_COUNTER_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_VALUE = 25;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_OFST = 311;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_VALMASK = 32'h00000019;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR0_FIELD_VALUE = 8'h19;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_OFST = 312;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_SIZE = 4;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_BITMASK = 32'h0000000F;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_LOCK_FLTR_CFG_ADDR1_FIELD_VALUE = 4'h0;

localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_VALUE = "pll_lock_fltr_nrm";
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_OFST = 312;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_LOCK_FLTR_TEST_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_VALUE = 2;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_OFST = 312;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_BITMASK = 32'h00000070;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_VALMASK = 32'h00000020;
localparam CMU_FPLL_PLL_UNLOCK_FLTR_CFG_ADDR_FIELD_VALUE = 3'h2;

localparam CMU_FPLL_PLL_M_COUNTER_VALUE = 20;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_OFST = 299;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_SIZE = 8;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_VALMASK = 32'h00000014;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR0_FIELD_VALUE = 8'h14;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_OFST = 300;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_M_COUNTER_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_OFST = 275;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_VALMASK = 32'h00000010;
localparam CMU_FPLL_PLL_M_COUNTER_MIN_TCO_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_VALUE = "m_cnt_in_src_ph_mux_clk";
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_OFST = 296;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_BITMASK = 32'h00000060;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_M_COUNTER_IN_SRC_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_N_COUNTER_VALUE = 1;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_OFST = 300;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_SIZE = 5;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_BITMASK = 32'h000000F8;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_VALMASK = 32'h00000008;
localparam CMU_FPLL_PLL_N_COUNTER_ADDR_FIELD_VALUE = 5'h1;

localparam CMU_FPLL_PLL_TCLK_MUX_EN_VALUE = "false";
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_TCLK_MUX_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_TCLK_SEL_VALUE = "pll_tclk_m_src";
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_OFST = 310;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_VALMASK = 32'h00000020;
localparam CMU_FPLL_PLL_TCLK_SEL_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_DPRIO_BASE_ADDR_VALUE = 256;

localparam CMU_FPLL_PLL_DPRIO_BROADCAST_EN_VALUE = "false";

localparam CMU_FPLL_PLL_DPRIO_CVP_INTER_SEL_VALUE = "false";

localparam CMU_FPLL_PLL_DPRIO_FORCE_INTER_SEL_VALUE = "false";

localparam CMU_FPLL_PLL_DPRIO_POWER_ISO_EN_VALUE = "false";

localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_VALUE = "dprio_normal_status";
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_OFST = 313;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_BITMASK = 32'h000000E0;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_DPRIO_STATUS_SELECT_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_PLL_EXTRA_CSR_VALUE = 0;

localparam CMU_FPLL_PLL_NRESET_INVERT_VALUE = "false";
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_OFST = 258;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_NRESET_INVERT_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_VALUE = "true";
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_OFST = 258;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_CTRL_OVERRIDE_SETTING_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_ENABLE_VALUE = "true";
localparam CMU_FPLL_PLL_ENABLE_ADDR_OFST = 258;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_VALMASK = 32'h00000010;
localparam CMU_FPLL_PLL_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam CMU_FPLL_PLL_SELF_RESET_VALUE = "false";
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_OFST = 258;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_SELF_RESET_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_TEST_ENABLE_VALUE = "false";
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_OFST = 258;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_OFST = 1;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_HIGH = 1;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_BITMASK = 32'h00000002;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR0_FIELD_VALUE = 1'h0;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_OFST = 296;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_TEST_ENABLE_ADDR1_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_VALUE = "false";
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_OFST = 320;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_OFST = 7;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_CTRL_PLNIOTRI_OVERRIDE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_VCCR_PD_EN_VALUE = "true";
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_OFST = 258;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_HIGH = 0;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_BITMASK = 32'h00000001;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCCR_PD_EN_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_BW_SEL_VALUE = "medium";

localparam CMU_FPLL_COMPENSATION_MODE_VALUE = "direct";

localparam CMU_FPLL_DUTY_CYCLE_0_VALUE = 50;

localparam CMU_FPLL_DUTY_CYCLE_1_VALUE = 50;

localparam CMU_FPLL_DUTY_CYCLE_2_VALUE = 50;

localparam CMU_FPLL_DUTY_CYCLE_3_VALUE = 50;

localparam CMU_FPLL_HSSI_OUTPUT_CLOCK_FREQUENCY_VALUE = "2700.0 MHz";

localparam CMU_FPLL_IS_CASCADED_PLL_VALUE = "false";

localparam CMU_FPLL_OUTPUT_CLOCK_FREQUENCY_0_VALUE = "0 ps";

localparam CMU_FPLL_OUTPUT_CLOCK_FREQUENCY_1_VALUE = "0 ps";

localparam CMU_FPLL_OUTPUT_CLOCK_FREQUENCY_2_VALUE = "0 ps";

localparam CMU_FPLL_OUTPUT_CLOCK_FREQUENCY_3_VALUE = "0 ps";

localparam CMU_FPLL_PHASE_SHIFT_0_VALUE = "0 ps";

localparam CMU_FPLL_PHASE_SHIFT_1_VALUE = "0 ps";

localparam CMU_FPLL_PHASE_SHIFT_2_VALUE = "0 ps";

localparam CMU_FPLL_PHASE_SHIFT_3_VALUE = "0 ps";

localparam CMU_FPLL_REFERENCE_CLOCK_FREQUENCY_VALUE = "270.0 MHz";

localparam CMU_FPLL_VCO_FREQUENCY_VALUE = "10800.0 MHz";

localparam CMU_FPLL_CGB_DIV_VALUE = 1;

localparam CMU_FPLL_PMA_WIDTH_VALUE = 20;

localparam CMU_FPLL_F_OUT_C3_HZ_VALUE = "0 hz";

localparam CMU_FPLL_F_OUT_C1_HZ_VALUE = "0 hz";

localparam CMU_FPLL_F_OUT_C0_HZ_VALUE = "0 hz";

localparam CMU_FPLL_F_OUT_C2_HZ_VALUE = "0 hz";

localparam CMU_FPLL_F_OUT_C3_VALUE = "000000000000000000000000000000000000";

localparam CMU_FPLL_F_OUT_C1_VALUE = "000000000000000000000000000000000000";

localparam CMU_FPLL_F_OUT_C0_VALUE = "000000000000000000000000000000000000";

localparam CMU_FPLL_F_OUT_C2_VALUE = "000000000000000000000000000000000000";

localparam CMU_FPLL_M_COUNTER_C2_VALUE = 9'd1;

localparam CMU_FPLL_M_COUNTER_C3_VALUE = 9'd1;

localparam CMU_FPLL_M_COUNTER_C0_VALUE = 9'd1;

localparam CMU_FPLL_M_COUNTER_C1_VALUE = 9'd1;

localparam CMU_FPLL_PFD_FREQ_VALUE = "000000010000000101111101111110000000";

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_VALUE = "pll_vco_freq_band_0_fix_high_0";
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_OFST = 322;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_HIGH_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_VALUE = "pll_vco_freq_band_1_fix_high_0";
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_OFST = 322;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_HIGH_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_VALUE = "sel_8b_count";
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_OFST = 322;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_HIGH = 6;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_BITMASK = 32'h00000040;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_CAL_VCO_COUNT_LENGTH_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_VALUE = "pulse_width_setting0";
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_OFST = 322;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_HIGH = 1;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_BITMASK = 32'h00000003;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_PULSE_WIDTH_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_VALUE = 2'd0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_OFST = 292;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_BITMASK = 32'h000000C0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_HIGH_BITS_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_VALUE = 8'd0;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_OFST = 323;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_SIZE = 8;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_SET_FPLL_INPUT_FREQ_RANGE_ADDR_FIELD_VALUE = 8'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_VALUE = 5'd1;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_OFST = 266;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_SIZE = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_BITMASK = 32'h0000001F;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_FIX_ADDR_FIELD_VALUE = 5'h1;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_VALUE = 2'd0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_OFST = 267;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_OFST = 6;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_HIGH = 7;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_BITMASK = 32'h000000C0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_HIGH_BITS_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_VALUE = 5'd1;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_OFST = 291;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_OFST = 0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_SIZE = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_BITMASK = 32'h0000001F;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_FIX_ADDR_FIELD_VALUE = 5'h1;

localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_VALUE = "normal_setting";
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_OFST = 321;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_OFST = 5;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_BITMASK = 32'h00000020;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_XPM_CPVCO_FPLL_XPM_CHGPMPLF_FPLL_CP_CURRENT_BOOST_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_VALUE = "normal_refclk";
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_OFST = 321;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_OFST = 4;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_HIGH = 4;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_SIZE = 1;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_BITMASK = 32'h00000010;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_FPLL_REFCLK_SOURCE_ADDR_FIELD_VALUE = 1'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_VALUE = 3'd0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_OFST = 267;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_BITMASK = 32'h00000038;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_0_DYN_LOW_BITS_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_VALUE = "normal_delay";
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_OFST = 322;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_OFST = 2;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_HIGH = 3;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_SIZE = 2;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_XPM_CMU_FPLL_CORE_PFD_DELAY_COMPENSATION_ADDR_FIELD_VALUE = 2'h0;

localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_VALUE = 3'd0;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_OFST = 292;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_OFST = 3;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_HIGH = 5;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_SIZE = 3;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_BITMASK = 32'h00000038;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam CMU_FPLL_PLL_VCO_FREQ_BAND_1_DYN_LOW_BITS_ADDR_FIELD_VALUE = 3'h0;

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_CLK_SEL_OVERRIDE_VALUE = "normal";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_CLK_SEL_OVERRIDE_VALUE_VALUE = "select_clk0";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_AUTO_CLK_SW_EN_VALUE = "false";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_CLK_LOSS_EDGE_VALUE = "pll_clk_loss_both_edges";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_CLK_LOSS_SW_EN_VALUE = "false";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_CLK_SW_DLY_VALUE = 0;

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_MANU_CLK_SW_EN_VALUE = "false";

localparam CMU_FPLL_REFCLK_SELECT_MUX_PLL_SW_REFCLK_SRC_VALUE = "pll_sw_refclk_src_clk_0";

localparam CMU_FPLL_REFCLK_SELECT_MUX_SILICON_REV_VALUE = "20nm5es";

localparam CMU_FPLL_REFCLK_SELECT_MUX_REFCLK_SELECT0_VALUE = "lvpecl";

localparam CMU_FPLL_REFCLK_SELECT_MUX_REFCLK_SELECT1_VALUE = "ref_iqclk0";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX0_INCLK0_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "lvpecl";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX0_INCLK1_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX0_INCLK2_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX0_INCLK3_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX0_INCLK4_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX1_INCLK0_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "lvpecl";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX1_INCLK1_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX1_INCLK2_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX1_INCLK3_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam CMU_FPLL_REFCLK_SELECT_MUX_MUX1_INCLK4_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

endpackage