	component subsys_dp_frame_buf is
		port (
			control_address             : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- address
			control_byteenable          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- byteenable
			control_write               : in  std_logic                      := 'X';             -- write
			control_writedata           : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- writedata
			control_read                : in  std_logic                      := 'X';             -- read
			control_readdata            : out std_logic_vector(31 downto 0);                     -- readdata
			control_readdatavalid       : out std_logic;                                         -- readdatavalid
			control_waitrequest         : out std_logic;                                         -- waitrequest
			control_interrupt_irq       : out std_logic;                                         -- irq
			dout_data                   : out std_logic_vector(31 downto 0);                     -- data
			dout_valid                  : out std_logic;                                         -- valid
			dout_startofpacket          : out std_logic;                                         -- startofpacket
			dout_endofpacket            : out std_logic;                                         -- endofpacket
			dout_ready                  : in  std_logic                      := 'X';             -- ready
			main_clock                  : in  std_logic                      := 'X';             -- clk
			main_reset                  : in  std_logic                      := 'X';             -- reset
			mem_master_rd_address       : out std_logic_vector(31 downto 0);                     -- address
			mem_master_rd_burstcount    : out std_logic_vector(6 downto 0);                      -- burstcount
			mem_master_rd_waitrequest   : in  std_logic                      := 'X';             -- waitrequest
			mem_master_rd_read          : out std_logic;                                         -- read
			mem_master_rd_readdata      : in  std_logic_vector(127 downto 0) := (others => 'X'); -- readdata
			mem_master_rd_readdatavalid : in  std_logic                      := 'X'              -- readdatavalid
		);
	end component subsys_dp_frame_buf;

	u0 : component subsys_dp_frame_buf
		port map (
			control_address             => CONNECTED_TO_control_address,             --           control.address
			control_byteenable          => CONNECTED_TO_control_byteenable,          --                  .byteenable
			control_write               => CONNECTED_TO_control_write,               --                  .write
			control_writedata           => CONNECTED_TO_control_writedata,           --                  .writedata
			control_read                => CONNECTED_TO_control_read,                --                  .read
			control_readdata            => CONNECTED_TO_control_readdata,            --                  .readdata
			control_readdatavalid       => CONNECTED_TO_control_readdatavalid,       --                  .readdatavalid
			control_waitrequest         => CONNECTED_TO_control_waitrequest,         --                  .waitrequest
			control_interrupt_irq       => CONNECTED_TO_control_interrupt_irq,       -- control_interrupt.irq
			dout_data                   => CONNECTED_TO_dout_data,                   --              dout.data
			dout_valid                  => CONNECTED_TO_dout_valid,                  --                  .valid
			dout_startofpacket          => CONNECTED_TO_dout_startofpacket,          --                  .startofpacket
			dout_endofpacket            => CONNECTED_TO_dout_endofpacket,            --                  .endofpacket
			dout_ready                  => CONNECTED_TO_dout_ready,                  --                  .ready
			main_clock                  => CONNECTED_TO_main_clock,                  --        main_clock.clk
			main_reset                  => CONNECTED_TO_main_reset,                  --        main_reset.reset
			mem_master_rd_address       => CONNECTED_TO_mem_master_rd_address,       --     mem_master_rd.address
			mem_master_rd_burstcount    => CONNECTED_TO_mem_master_rd_burstcount,    --                  .burstcount
			mem_master_rd_waitrequest   => CONNECTED_TO_mem_master_rd_waitrequest,   --                  .waitrequest
			mem_master_rd_read          => CONNECTED_TO_mem_master_rd_read,          --                  .read
			mem_master_rd_readdata      => CONNECTED_TO_mem_master_rd_readdata,      --                  .readdata
			mem_master_rd_readdatavalid => CONNECTED_TO_mem_master_rd_readdatavalid  --                  .readdatavalid
		);

