// subsys_dp_frame_buf.v

// Generated using ACDS version 17.0 290

`timescale 1 ps / 1 ps
module subsys_dp_frame_buf (
		input  wire [3:0]   control_address,             //           control.address
		input  wire [3:0]   control_byteenable,          //                  .byteenable
		input  wire         control_write,               //                  .write
		input  wire [31:0]  control_writedata,           //                  .writedata
		input  wire         control_read,                //                  .read
		output wire [31:0]  control_readdata,            //                  .readdata
		output wire         control_readdatavalid,       //                  .readdatavalid
		output wire         control_waitrequest,         //                  .waitrequest
		output wire         control_interrupt_irq,       // control_interrupt.irq
		output wire [31:0]  dout_data,                   //              dout.data
		output wire         dout_valid,                  //                  .valid
		output wire         dout_startofpacket,          //                  .startofpacket
		output wire         dout_endofpacket,            //                  .endofpacket
		input  wire         dout_ready,                  //                  .ready
		input  wire         main_clock,                  //        main_clock.clk
		input  wire         main_reset,                  //        main_reset.reset
		output wire [31:0]  mem_master_rd_address,       //     mem_master_rd.address
		output wire [6:0]   mem_master_rd_burstcount,    //                  .burstcount
		input  wire         mem_master_rd_waitrequest,   //                  .waitrequest
		output wire         mem_master_rd_read,          //                  .read
		input  wire [127:0] mem_master_rd_readdata,      //                  .readdata
		input  wire         mem_master_rd_readdatavalid  //                  .readdatavalid
	);

	subsys_dp_frame_buf_alt_vip_cl_vfb_170_huzpusq #(
		.BITS_PER_SYMBOL              (8),
		.NUMBER_OF_COLOR_PLANES       (4),
		.COLOR_PLANES_ARE_IN_PARALLEL (1),
		.PIXELS_IN_PARALLEL           (1),
		.READY_LATENCY                (1),
		.MAX_WIDTH                    (1280),
		.MAX_HEIGHT                   (720),
		.CLOCKS_ARE_SEPARATE          (0),
		.MEM_PORT_WIDTH               (128),
		.MEM_BASE_ADDR                (0),
		.BURST_ALIGNMENT              (1),
		.WRITE_FIFO_DEPTH             (256),
		.WRITE_BURST_TARGET           (64),
		.READ_FIFO_DEPTH              (256),
		.READ_BURST_TARGET            (64),
		.WRITER_RUNTIME_CONTROL       (0),
		.READER_RUNTIME_CONTROL       (1),
		.IS_FRAME_WRITER              (0),
		.IS_FRAME_READER              (1),
		.DROP_FRAMES                  (1),
		.REPEAT_FRAMES                (1),
		.DROP_REPEAT_USER             (0),
		.INTERLACED_SUPPORT           (0),
		.CONTROLLED_DROP_REPEAT       (0),
		.DROP_INVALID_FIELDS          (1),
		.MULTI_FRAME_DELAY            (1),
		.IS_SYNC_MASTER               (0),
		.IS_SYNC_SLAVE                (0),
		.USER_PACKETS_MAX_STORAGE     (0),
		.MAX_SYMBOLS_PER_PACKET       (10),
		.NUM_BUFFERS                  (3)
	) frame_buf (
		.control_address             (control_address),             //           control.address
		.control_byteenable          (control_byteenable),          //                  .byteenable
		.control_write               (control_write),               //                  .write
		.control_writedata           (control_writedata),           //                  .writedata
		.control_read                (control_read),                //                  .read
		.control_readdata            (control_readdata),            //                  .readdata
		.control_readdatavalid       (control_readdatavalid),       //                  .readdatavalid
		.control_waitrequest         (control_waitrequest),         //                  .waitrequest
		.control_interrupt_irq       (control_interrupt_irq),       // control_interrupt.irq
		.dout_data                   (dout_data),                   //              dout.data
		.dout_valid                  (dout_valid),                  //                  .valid
		.dout_startofpacket          (dout_startofpacket),          //                  .startofpacket
		.dout_endofpacket            (dout_endofpacket),            //                  .endofpacket
		.dout_ready                  (dout_ready),                  //                  .ready
		.main_clock                  (main_clock),                  //        main_clock.clk
		.main_reset                  (main_reset),                  //        main_reset.reset
		.mem_master_rd_address       (mem_master_rd_address),       //     mem_master_rd.address
		.mem_master_rd_burstcount    (mem_master_rd_burstcount),    //                  .burstcount
		.mem_master_rd_waitrequest   (mem_master_rd_waitrequest),   //                  .waitrequest
		.mem_master_rd_read          (mem_master_rd_read),          //                  .read
		.mem_master_rd_readdata      (mem_master_rd_readdata),      //                  .readdata
		.mem_master_rd_readdatavalid (mem_master_rd_readdatavalid)  //                  .readdatavalid
	);

endmodule
